package dst.net.droid;


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;

import dst.net.jsonObj.FreezeSalesOrderLine;
import dst.net.jsonObj.FreezeSalesOrderLineModifier;
import dst.net.jsonObj.FreezeSalesOrderLineOption;
import dst.net.jsonObj.Promotion;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.*;
import android.content.res.Resources;
import android.os.Environment;
import android.os.Handler;
import android.util.Log;
import android.util.TypedValue;
import android.view.KeyEvent;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.TextView;
import android.widget.TextView.OnEditorActionListener;

public class AndroidOperations {
	

	private Context _context;
	private Resources _resources;
	public static String DeviceID;

	
	public static  boolean CacheCleared = false;
	public static  boolean CurrentExpanMode = true;
	public static  int CurrentEmployee ;
	public static  String CurrentEmployeeName ;
	public static int CurrentTable;
	public static  int CurrentTableSubOrder;
   	public static  SaleData OrderData = new SaleData();
   	public static  int CurrentTableTariff;
   	public static int  CreateNewSubOrderNumber = -1;
   	public static boolean HasLends = false;
   	public static boolean HasPrepays = false;
   	public static int CurrentTableDiner=1;
	public static List<Integer> CurrentMenuAvailableDiners;
	public static List<Promotion> CurrentArticlePromos;
	public static String TableName = "";
	public static int TableMember = 0;
   	
	private static final String TAG = MainActivity.class.getName();
	
	public AndroidOperations(Context context)
	{
		_context = context;
		_resources = _context.getResources();
	}
	
	public void ShowMessage(String title, String text)
    {
		ShowMessage(_context, title, text);
    }
	
	public void ShowMessage(Context context, String title, String text)
    {
        new AlertDialog.Builder(context) 

		.setTitle(title) 
		.setIcon(R.drawable.ic_dialog_icon)
		.setMessage(text) 
		.setCancelable(false)
		.setNeutralButton("Ok",
		new DialogInterface.OnClickListener() { 
						
				public void onClick(DialogInterface dialog,
							int which) { 
									   } 

		}).show(); 
    }
	
	public FreezeSalesOrderLine GetLine(int id)
	{
		FreezeSalesOrderLine result = new FreezeSalesOrderLine();
		
		if (OrderData.SaleLines.size()>0)
        {
        	Iterator<FreezeSalesOrderLine> i = OrderData.SaleLines.values().iterator();

        	while(i.hasNext())
        	{
        		
        		FreezeSalesOrderLine l = (FreezeSalesOrderLine) i.next();
        		
        		if (l.IdLine == id)
        			return l;
        	}
        }
		
			result.IdLine = -1;
			
			return result;
	}

	public void performClickOnDone(TextView editView, final View button){ 
		editView.setOnEditorActionListener(new OnEditorActionListener() {
			
			public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
				// TODO Auto-generated method stub
				
				button.requestFocus(); 
	            button.performClick(); 
	            return true; 
			}
		}); 
	}
	
	public boolean CompareLines(FreezeSalesOrderLine lineA,FreezeSalesOrderLine lineB )
    {
		if (lineA==null)
			return false;
		
		if (lineB==null)
			return false;
    	
    	if (lineA.Invited == lineB.Invited && 
    		lineA.Article == lineB.Article &&
    		lineA.CourseNumber == lineB.CourseNumber &&
    		lineA.Price == lineB.Price &&
    		CompareModifiers(lineA.Modifiers, lineB.Modifiers) && 
    		CompareOptions(lineA.Options, lineB.Options)
   			)
    	{
    		return true;
    	}
    	else
    		return false;
    }
	
	private boolean CompareModifiers(FreezeSalesOrderLineModifier[] lineA,  FreezeSalesOrderLineModifier[] lineB)
	{
		if (lineA == null && lineB == null)
			return true;
		if (lineA == null && lineB != null)
			return false;
		if (lineA != null && lineB == null)
			return false;
		if (lineA.length!= lineB.length)
			return false;

		for(int i=0; i< lineA.length; i++)
		{
			boolean found = false;
			
			for (int j=0; j<lineB.length; j++)
			{
				if (lineA[i].Modifier == lineB[j].Modifier)
				{
					found = true;
					break;
				}
			}
			
			if (!found)
				return false;
		}
		
		
		return true;
	}
	
	private boolean CompareOptions(FreezeSalesOrderLineOption[] lineA,  FreezeSalesOrderLineOption[] lineB)
	{
		Map<Integer,Integer > indexFound = new HashMap<Integer,Integer>();
		
		if (lineA == null && lineB == null)
			return true;
		if (lineA == null && lineB != null)
			return false;
		if (lineA != null && lineB == null)
			return false;
		if (lineA.length!= lineB.length)
			return false;

		for(int i=0; i< lineA.length; i++)
		{
			boolean found = false;
			
			for (int j=0; j<lineB.length; j++)
			{
				if (lineA[i].Article == lineB[j].Article &&
					lineA[i].Price== lineB[j].Price && 
					indexFound.get(j)==null)
				{
					indexFound.put(j,j);
					found = true;
					break;
				}
			}
			
			if (!found)
				return false;
		}
		
		
		return true;
	}
	
	public int GetRealPixel(int dp)
    {
		return (int)TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, dp, _resources.getDisplayMetrics());
    }
	
	public void MakeActionPaymentStep1(Activity act, Handler handler)
    {
		_context = act;
		
    	if (AndroidOperations.HasLends) //Order Has Lends Question to continue
			ShowMessage(act.getString(R.string.SelectPayment), act.getString(R.string.ShowRegisterCantSaleLends));
        else if (AndroidOperations.HasPrepays) // Order Has Prepays Question to continue
        	ShowMessage(act.getString(R.string.SelectPayment), act.getString(R.string.ShowRegisterCantSalePrepay));
        else
        	MakeActionPaymentStep2(act,handler);
    }
	
	private void MakeActionPaymentStep2(final Activity act, final Handler handler)
	{
		Thread thread=new Thread( new Runnable() { 
		    public void run() { 
		 
				WcfOperations wcf = new WcfOperations();
		        
				double orderTotal = 0;
				try
				{
					orderTotal = wcf.GetOrderTotal();
				}
				catch (Exception e) 	
				{
					AndroidOperations.AppendLog("AdnOP_MakeActionPaymentStep2:" + e.getMessage());
		        	
				}
				
				if(Parameters.UsePaymentMethods)
				{
					Intent i = new Intent(act, ShowPayment.class);
					
					i.putExtra("orderTotal",orderTotal);
					act.startActivityForResult(i, 1);
				}
				else
				{
					Intent i = new Intent(act, ShowSelectTicketAct.class);
					
					i.putExtra("directPayment",true);
					i.putExtra("orderTotal",orderTotal);
					act.startActivityForResult(i, 5);
				}
		    	
		            //do your parsing;  //But do not update user interface here 
				handler.handleMessage(null); 
		    } 
		});
		
		thread.start();
	}

	public static void showInputMethod(final Activity activity, final TextView input){
	    
		  InputMethodManager imm = (InputMethodManager) activity.getSystemService(Context.INPUT_METHOD_SERVICE);
		  imm.toggleSoftInput(InputMethodManager.SHOW_FORCED,0);
	       
	  }
	  
	public static void hideInputMethod(final Activity activity, final View obj){
	    
		if (obj!=null)
		{
			InputMethodManager imm = (InputMethodManager) activity.getSystemService(Context.INPUT_METHOD_SERVICE);
			imm.hideSoftInputFromWindow(obj.getWindowToken(),0);
		}
	  }
	
	public static void AppendLog(String text) 
	{     
		try
		{
			Calendar calender = GregorianCalendar.getInstance();
		    int number = calender.get(Calendar.WEEK_OF_YEAR) % 2;
		    
		    
		    File logFile = new File(Environment.getExternalStorageDirectory() + "/dstdroidlog_"+ number + ".txt");
		   
		   if (!logFile.exists()) 
		   { 
		      try 
		      { 
		         logFile.createNewFile(); 
		         
		         //BufferedWriter for performance, true to set append to file flag 
			      BufferedWriter buf = new BufferedWriter(new FileWriter(logFile, true));  
			      buf.append(new Date().toLocaleString() + " - " + text); 
			      buf.newLine(); 
			      buf.close(); 
		      }  
		      catch (IOException e) 
		      { 
		         
		      } 
		   }else
		   {
			   Calendar calendar = Calendar.getInstance();
			   calendar.setTimeInMillis(logFile.lastModified());
			   
			   int fileNumber = calendar.get(Calendar.WEEK_OF_YEAR) % 2;
			   
			   if (number==fileNumber)
			   {
			   
				  BufferedWriter buf = new BufferedWriter(new FileWriter(logFile, true));  
			      buf.append(new Date().toLocaleString() + " - " + text); 
			      buf.newLine(); 
			      buf.close();
			   }
			   else
			   {
				   
				   logFile.delete();
				   
				   logFile.createNewFile();

				   BufferedWriter buf = new BufferedWriter(new FileWriter(logFile, true));  
				   buf.append(new Date().toLocaleString() + " - " + text); 
				   buf.newLine(); 
				   buf.close();
			   
			   }
		   }
	   } 
	   catch (Exception e) 
	   { 
	       
	   } 
	} 
	
	@SuppressWarnings("unused")
	public static boolean UploadLog()
	{
		boolean upl1 = UploadFileLog(0);
		boolean upl2 = UploadFileLog(1);
		
		return (upl1 && upl2);
	}
	
	public static boolean UploadFileLog(int number)
	{
	    
		String FILENAME = Environment.getExternalStorageDirectory() + "/dstdroidlog_"+ number + ".txt";
		String ret = "";
        
        try 
        {
            
            FileInputStream fis = new FileInputStream (new File(FILENAME));
            
            if ( fis != null ) 
            {
                InputStreamReader inputStreamReader = new InputStreamReader(fis);
                BufferedReader bufferedReader = new BufferedReader(inputStreamReader);
                String receiveString = "";
                StringBuilder stringBuilder = new StringBuilder();
                 
                while ( (receiveString = bufferedReader.readLine()) != null ) {
                    stringBuilder.append(receiveString+"\n");
                }
                 
                bufferedReader.close();
                fis.close();
                ret = stringBuilder.toString();
                
                httpPAsteBinPostData(ret);
            }
             
            return true;
        }
        catch( Exception e)
        {
        	return false;
        }
	
	}
	
	public static void httpPAsteBinPostData(String textToSend) {
	    // Create a new HttpClient and Post Header
	    HttpClient httpclient = new DefaultHttpClient();
	    HttpPost httppost = new HttpPost("http://www.dstnet.com/pastebin.php");

	    try {
	        // Add your data
	        List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>(2);
	        nameValuePairs.add(new BasicNameValuePair("textLog", textToSend));
	        httppost.setEntity(new UrlEncodedFormEntity(nameValuePairs));

	        // Execute HTTP Post Request
	        HttpResponse response = httpclient.execute(httppost);
	        
	        HttpEntity ent = response.getEntity();/*y obtenemos una respuesta*/

	        String text = EntityUtils.toString(ent);
	        
	        Log.e(TAG,text);
	    } catch (ClientProtocolException e) {
	        // TODO Auto-generated catch block
	    } catch (IOException e) {
	        // TODO Auto-generated catch block
	    }
	} 
	
	public final static String AsUpperCaseFirstChar(final String target) {

	    if ((target == null) || (target.length() == 0)) {
	        return target; // You could omit this check and simply live with an
	                       // exception if you like
	    }
	    
	    boolean cap = true;
        char[]  out = target.toCharArray();
        int i, len = target.length();
        for(i=0; i<len; i++){
            if(Character.isWhitespace(out[i])){
                cap = true;
                continue;
            }
            if(cap){
                out[i] = Character.toUpperCase(out[i]);
                cap = false;
            }
        }
        return new String(out);
	}
}
