package dst.net.droid;

import dst.net.jsonObj.ItemDataNode;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.GridView;
import android.widget.TextView;

public class AskPiecesAct extends Activity {
	
	private int _article;
	private int _idLine;
	private boolean _pressed;
	private Handler _handler;
	private Runnable _runnableDisableGrid;
	private WcfOperations _wcf;
	private ItemDataNode _itemParent;
	private double _forcePrice;
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
	
        
        setContentView(R.layout.askpieces);
        
        Bundle extras = getIntent().getExtras();
        _article= extras.getInt("article",0);
        _idLine = extras.getInt("idLine",-1);
        _forcePrice = extras.getDouble("price",-1);

        _pressed= true;
        _handler = new Handler();
        
        _runnableDisableGrid = new Runnable()
       	{ 
       		public void run() 
       		{  
       			_pressed = false;
       		}
       	};
        
        _wcf = new WcfOperations();
      
        try
        {
        	_itemParent = _wcf.GetArticleInfo(_article);
        }
        catch (Exception e) {
        	
        	AndroidOperations.AppendLog("AskPieces_GetArticleInfo:" + e.getMessage());
        	
        	setResult(RESULT_FIRST_USER);
        	finish();
		}
        
        final Button cancelButton = (Button) findViewById(R.id.askPiecesBtnCancel);
        cancelButton.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {

				if (_pressed)
					return;
				
				_pressed = true;
				
				Bundle bundle = new Bundle();
	            bundle.putInt("idLine", _idLine);
	            Intent i = new Intent();
	            i.putExtras(bundle);
				
				setResult(RESULT_CANCELED, i);
				finish();
			}
		});
        
        final TextView txtArticle = (TextView) findViewById(R.id.askPiecesTxtArticle);
        txtArticle.setText(_itemParent.TicketText + " " + getString(R.string.AskPiecesTitle));
	
        final GridView gridViewOptions = (GridView) findViewById(R.id.askPiecesGridView);
	

        gridViewOptions.setNumColumns(Parameters.ArticleColumns);
        
        
        try
        {
        	PiecesAdapter pAdapter = new PiecesAdapter( _article,_idLine, this);
        	gridViewOptions.setAdapter(pAdapter);
        	
        	if (pAdapter.getCount()==1)
            {
        		_pressed=false;
            	EventDataClick((ItemDataNode)pAdapter.getItem(0));
            }
        	else
            _handler.postDelayed(_runnableDisableGrid, 500);
        }
        catch (Exception e) {
        	
        	AndroidOperations.AppendLog("PiecesAdapter:" + e.getMessage());
        	setRequestedOrientation(RESULT_FIRST_USER);
        	finish();
		}
			
        
	}
	
	public void EventDataClick(ItemDataNode idItem)
	{
		if (_pressed)
			return;
		
		_pressed = true;
		
		String newDescription = idItem.Description3 + "/ " +  _itemParent.TicketText;
		
		if (idItem.Description3.trim().length()==0)
			newDescription = idItem.Description1.trim() + " " +	idItem.Description2.trim()	+ " - " +  _itemParent.TicketText;
		
		double newPrice = idItem.GetCurrentPrice();

		if (_forcePrice>=0)
			newPrice = _forcePrice;
		
		Bundle bundle = new Bundle();
        
        bundle.putInt("idLine", _idLine);
        bundle.putString("newdescription", newDescription);
        bundle.putDouble("newPrice",newPrice );
        bundle.putInt("piece",idItem.Number );
        bundle.putBoolean("dontshowoptionals",idItem.DontShowOptionalsOnPiece);
        
        
        Intent i = new Intent();
        
        i.putExtras(bundle);
        setResult(RESULT_OK, i);
        finish();
	}
}
