package dst.net.droid;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.TextView;

public class AskPriceAct extends Activity {

	private AndroidOperations _andOP;
	private double _selectedPrice;
	private boolean _pressed;
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
	
	
        setContentView(R.layout.askprice);
        
        _pressed = false;
        _selectedPrice = 0;
        final TextView txtNewPrice = (TextView) findViewById(R.id.askPriceTxtAmount);
        final Button btnAccept = (Button)findViewById(R.id.askPriceBtnAccept);
        final Button btnCancel = (Button) findViewById(R.id.askPriceBtnCancel);
        
        btnAccept.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {

				if (_pressed)
					return;
				
				_pressed= true;
				
				AndroidOperations.hideInputMethod(AskPriceAct.this, btnAccept);
				AcceptPrice();
			}
		});
        
        btnCancel.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {

				if (_pressed)
					return;
				
				_pressed= true;
				
				AndroidOperations.hideInputMethod(AskPriceAct.this, btnAccept);
				setResult(RESULT_CANCELED);
				finish();
			}
		});
        
        _andOP = new AndroidOperations(this);
        _andOP.performClickOnDone(txtNewPrice, btnAccept);
	}
	
    @Override 
    protected void onResume(){ 
        super.onResume(); 
        
        final TextView txtNewPrice = (TextView) findViewById(R.id.askPriceTxtAmount);
        
        txtNewPrice.postDelayed(new Runnable() { 
            public void run() { 
                InputMethodManager keyboard = (InputMethodManager) 
                getSystemService(Context.INPUT_METHOD_SERVICE); 
                keyboard.showSoftInput(txtNewPrice, 0);  
            } 
        },Parameters.KeyboardWait);
    }
    
    private void AcceptPrice()
    {
    	final TextView txtNewPrice = (TextView) findViewById(R.id.askPriceTxtAmount);
    	
    	try 
        {
    		_selectedPrice = Double.valueOf(txtNewPrice.getText().toString());
    		
            MakeChangePrice();
        }
        catch (Exception ex)
        {
        	txtNewPrice.setText("");
        	txtNewPrice.requestFocus();

            _andOP.ShowMessage(getString(R.string.AskPrice),getString(R.string.AskPriceInvalid));
        }
    
    	_pressed= false;
    }
    
    private void MakeChangePrice()
    {
        Bundle bundle = new Bundle();
        bundle.putDouble("newPrice", _selectedPrice);

        Intent i = new android.content.Intent();
        i.putExtras(bundle);

        setResult(RESULT_OK, i);

        finish();
    }
	
}
