package dst.net.droid;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.TextView;

public class AskTableMembersAct extends Activity {
	
	private boolean _newsale;
	private boolean _pressed;
	
	 public void onCreate(Bundle savedInstanceState) {
	        super.onCreate(savedInstanceState);

	        setContentView(R.layout.asktablemembers);
	        
	        _pressed = false;
	        final Button btnBack =(Button) findViewById(R.id.buttonBackTableMembers); 
	        final Button btnOK =(Button) findViewById(R.id.buttonAcceptTableMembers);
	        final TextView textMembers =(TextView) findViewById(R.id.textTableMembers);
	        
	        if (AndroidOperations.TableMember > 0)
	        {	
	        	textMembers.setText(String.valueOf(AndroidOperations.TableMember));
	        	textMembers.setSelectAllOnFocus(true);
	        }
	        
	        AndroidOperations _andOP = new AndroidOperations(AskTableMembersAct.this);
	        _andOP.performClickOnDone(textMembers, btnOK);
	        
	        Bundle extras = getIntent().getExtras();
	        _newsale= extras.getBoolean("newsale",false);
	        
            btnBack.setOnClickListener(new OnClickListener() {
				
				public void onClick(View v) {

					if (_pressed)
						return;
							
					_pressed= true;
					
					AndroidOperations.hideInputMethod(AskTableMembersAct.this, v);
					CancelTableMembers();
				}
			});
            
            btnOK.setOnClickListener(new OnClickListener() {
				
            public void onClick(View v) {
					
					if (_pressed)
						return;
							
					_pressed= true;
					
					AndroidOperations.hideInputMethod(AskTableMembersAct.this, v);
					GetTableMembers();
				}
		
            });
	 }
	 
	    protected void onResume(){ 
	        super.onResume(); 
	        
	        final TextView txtkeyboard = (TextView) findViewById(R.id.textTableMembers);
	        
	        txtkeyboard.postDelayed(new Runnable() { 
	            public void run() { 
	                InputMethodManager keyboard = (InputMethodManager) 
	                getSystemService(Context.INPUT_METHOD_SERVICE); 
	                keyboard.showSoftInput(txtkeyboard, 0);  
	            } 
	        },200);
	    } 
	 
	 private void CancelTableMembers()
	 {
		 Bundle bundle = new Bundle();
         
		    bundle.putInt("tablemembers", 1);
		    bundle.putBoolean("newsale", _newsale);

		    Intent i = new Intent();

		    i.putExtras(bundle);
		    setResult(RESULT_CANCELED, i);
		    finish();
	 }
	 
	 @Override 
	 public void onBackPressed() 
	 { 
		 CancelTableMembers();
	 }
	 
	 private void GetTableMembers()
	 {
		 final TextView textMembers =(TextView) findViewById(R.id.textTableMembers);
		 
		 try
		 {
			 int tableMembers = new Integer(textMembers.getText().toString());

			 Bundle bundle = new Bundle();
             
			    bundle.putInt("tablemembers", tableMembers);
			    bundle.putBoolean("newsale", _newsale);


			    Intent i = new Intent();

			    i.putExtras(bundle);
			    setResult(RESULT_OK, i);
			    finish();
		 }
         catch(Exception ex)
         {
             AndroidOperations andOP = new AndroidOperations(this);
             andOP.ShowMessage(getString(R.string.AskTableMembers),getString( R.string.AskTableMembersError));
         }
		 
		 _pressed = false;
	 }
}
