package dst.net.droid;

import java.io.File;

import android.app.Activity;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.TextView;
import android.widget.Toast;

public class Configuration extends Activity {
	
	private boolean _pressed;
	
	 @Override
	    public void onCreate(Bundle savedInstanceState) {
	        super.onCreate(savedInstanceState);
        
	        setContentView(R.layout.configuration);
	        
	        
	        _pressed= false;
	        final Button acceptButton = (Button) findViewById(R.id.confAccept);
	        final Button cancelButton = (Button) findViewById(R.id.confCancel);
	        final TextView textI = (TextView) findViewById(R.id.confTextIP);
	        final TextView textPort = (TextView) findViewById(R.id.confTextPort);
	        final TextView textSize = (TextView) findViewById(R.id.confTextFontSize);
	        final TextView textColumns = (TextView) findViewById(R.id.confTextColumns);
	        final CheckBox chkPayMethod = (CheckBox) findViewById(R.id.confCheckPayMethods);
	        final CheckBox chkDontPay = (CheckBox) findViewById(R.id.confCheckCanPay);
	        final Button btnClearCache = (Button) findViewById(R.id.contBtnClearCache);
	        final TextView textPass = (TextView) findViewById(R.id.confTextPassword);
	        final CheckBox chkLineTool = (CheckBox) findViewById(R.id.confCheckLineTool);
	        final TextView textTimeOut = (TextView) findViewById(R.id.confTextTimeOut);
	        final CheckBox chkVMode =  (CheckBox) findViewById(R.id.confCheckVMode);
	        final Button sendLog = (Button) findViewById(R.id.confSendLog);
	        textI.setText(Parameters.WCFIp);
	        textPort.setText(Parameters.WCFPort);
	        textSize.setText(String.valueOf(Parameters.SizeFont));
	        textColumns.setText(String.valueOf(Parameters.ArticleColumns));
	        chkPayMethod.setChecked(Parameters.UsePaymentMethods);
	        chkDontPay.setChecked(Parameters.DontAllowPays);
	        textPass.setText(Parameters.Password);
	        textPort.setEnabled(false);
	        chkLineTool.setChecked(Parameters.ShowLineToolBar);
	        textTimeOut.setText(String.valueOf(Parameters.WcfTimeOut/1000));
	        chkVMode.setChecked(Parameters.VerticalMode);
	        
	        
	        sendLog.setOnClickListener(new OnClickListener() {
				
				public void onClick(View v) {
					
					if (AndroidOperations.UploadLog())
						 Toast.makeText(Configuration.this,"Log Uploaded OK", Toast.LENGTH_SHORT).show();
					else
						Toast.makeText(Configuration.this,"Log Upload Failed", Toast.LENGTH_SHORT).show();
					
				}
			});
	        
	        acceptButton.setOnClickListener(new OnClickListener() {
				
				public void onClick(View v) {
					// TODO Auto-generated method stub
					try
		            {
						if (_pressed)
							return;
						
						_pressed= true;
						
		                Parameters.WCFIp= textI.getText().toString().trim();
		                Parameters.WCFPort= textPort.getText().toString();
		                Parameters.SizeFont= Integer.parseInt(textSize.getText().toString());
		                Parameters.ArticleColumns= Integer.parseInt(textColumns.getText().toString());
		                Parameters.Password= textPass.getText().toString();
		                
		                Parameters.WcfUrl =  "http://" + Parameters.WCFIp + ":" + Parameters.WCFPort +"/dstwcf/";  //Emulator
		                Parameters.UsePaymentMethods = chkPayMethod.isChecked();
		                Parameters.DontAllowPays = chkDontPay.isChecked();
		                Parameters.ShowLineToolBar = chkLineTool.isChecked();
		                Parameters.WcfTimeOut =1000 * Integer.valueOf(textTimeOut.getText().toString());
		                Parameters.VerticalMode = chkVMode.isChecked();
		                
		                
		                SharedPreferences share = PreferenceManager.getDefaultSharedPreferences(Configuration.this);
		                SharedPreferences.Editor editor  = share.edit();

		                editor.putString("ip", Parameters.WCFIp);
		                editor.putString("port", Parameters.WCFPort);
		                editor.putInt("sizefont", Parameters.SizeFont);
		                editor.putInt("columns", Parameters.ArticleColumns);
		                editor.putBoolean("usepaymethods", Parameters.UsePaymentMethods);
		                editor.putString("password", Parameters.Password);
		                editor.putBoolean("showlinetoolbar", Parameters.ShowLineToolBar);
		                editor.putInt("timeout", Parameters.WcfTimeOut);
		                editor.putBoolean("dontallowpay", Parameters.DontAllowPays);
		                editor.putBoolean("vmode", Parameters.VerticalMode);
		                
		                editor.commit();
		                
		                setResult(RESULT_OK);

		                finish();
		            }
		            catch (Exception ex)
		            {
		                Toast.makeText(Configuration.this, "Cant Store Data", Toast.LENGTH_SHORT);
		            }
					
					_pressed= false;
				}
			});
	        
	        cancelButton.setOnClickListener(new OnClickListener() {
				
				public void onClick(View v) {
					
					if (_pressed)
						return;
					
					_pressed= true;
					
					finish();
				}
			});
	        
	        btnClearCache.setOnClickListener(new OnClickListener() {
				
				public void onClick(View v) {
					
					if (_pressed)
						return;
					
					
					AndroidOperations.CacheCleared = true;
					
						 String dirPath = Parameters.FileImagePath;
						 
						 File dir = new File(dirPath);
						 
						 if (dir.isDirectory()) { 
						        String[] children = dir.list(); 
						        for (int j = 0; j < children.length; j++) { 
						            new File(dir, children[j]).delete(); 
						        } 
						    } 
						 
						 dirPath = Parameters.FileImagePathRender;
						 dir = new File(dirPath);
						 
						 if (dir.isDirectory()) { 
						        String[] children = dir.list(); 
						        for (int j = 0; j < children.length; j++) { 
						            new File(dir, children[j]).delete(); 
						        } 
						 } 
					
					Toast.makeText(Configuration.this, R.string.ClearCacheOK,Toast.LENGTH_SHORT  ).show();
					 
					 _pressed= false;
				}
			});
	 }
}
