package dst.net.droid;

import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;


public class Item {
	
	private static final int BUFFER_SIZE = 0x1000; // 4K

	private static Map<Integer, ItemData> _items= new HashMap<Integer, ItemData>();
	//public static List<Article> ArticleImage;
	public static Map<Integer, String> ArticleImageMap;

	public static void ClearItems()
	{
		if (_items!= null)
			_items.clear();
		
	/*	if (ArticleImage!=null)
			ArticleImage.clear();*/
		
		if (ArticleImageMap!=null)
			ArticleImageMap.clear();
	}
	
	public static int GetTotalItems()
	{
		if (_items==null)
			return 0;
		else
			return _items.size();
		
	}
	
	public static ItemData GetFolder(int folder)
	{
		ItemData item= _items.get(folder);
		
		if (item==null)
		{
			ItemData newItemData = new ItemData(folder, 1);
			
			_items.put(folder,newItemData);
			
			return newItemData;
		}
		else
		{
			return item;
		}
	}
	
	public static int GetParent(int article)
	{
		Iterator<ItemData> i = 	_items.values().iterator();
			
		while (i.hasNext())
		{
			ItemData id =(ItemData) i.next();
			
			if (id.GetArticle(article)!=null)
			{
				return id.Root;
			}
		}
		
		return -1;
	}
	
	
	public static ItemData GetOptionals(int root, int idLine, int piece, boolean fromMenu)
	{
		ItemData newItemDataOptions = new ItemData(root, 2,idLine, piece, fromMenu);
		
		return newItemDataOptions;
	}
	
	public static ItemData GetPieces(int root, int idLine)
	{
		ItemData newItemDataPieces = new ItemData(root, 3,idLine,-1, false);
		
		return newItemDataPieces;
	}
	
	public static byte[]  GetImage(int article)
	{
		if (ArticleImageMap==null)
			return null;
		
		String path = ArticleImageMap.get(article);

		if (path!= null &&  path.length()>0)
		{
			try 
			{
				FileInputStream fin; 

				fin = new FileInputStream(path); 
				BufferedInputStream bis = new BufferedInputStream(fin);
				DataInputStream dis = new DataInputStream(bis);
				byte fileContent[] = toByteArray(dis);
				return fileContent;
			}
			catch (IOException e) 
			{
				AndroidOperations.AppendLog("Item_GetImage:" + e.getMessage());
				
				e.printStackTrace();
				return null;
			}
		}
		else
			return null;
	}
	
	public static byte[] toByteArray(InputStream in) throws IOException {
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		copy(in, out);
		return out.toByteArray();
		}
	
	public static long copy(InputStream from, OutputStream to) throws IOException {
		byte[] buf = new byte[BUFFER_SIZE];
		long total = 0;
		while (true) {
		int r = from.read(buf);
		if (r == -1) {
		break;
		}
		to.write(buf, 0, r);
		total += r;
		}
		return total;
		} 
	
	public static byte[] GetRenderImage(int article)
	{
		String path = Parameters.FileImagePathRender + article + ".jpg";

		if (path!= null &&  path.length()>0)
		{
			try 
			{
				FileInputStream fin; 

				fin = new FileInputStream(path);
				BufferedInputStream bis = new BufferedInputStream(fin);
				DataInputStream dis = new DataInputStream(bis);
				byte fileContent[] = toByteArray(dis);
				return fileContent;
			}
			catch (IOException e) 
			{
				return null;
			}
		}
		else
			return null;
	}

}
