package dst.net.droid;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import dst.net.jsonObj.ItemDataNode;

public class ItemData {

	public int Root;
	public Map<Integer, ItemDataNode> MapNodes;
	public List<ItemDataNode> Nodes;
	
	public ItemData(int root,int typeNode, int idLine, int piece, boolean fromMenu)
	{
		if (typeNode==1)  //articles
		{
			Root = root;
			MapNodes = new HashMap<Integer, ItemDataNode>();
			
			WcfOperations wcf = new WcfOperations();
			
			Nodes = wcf.GetArticleFolder(root);
			
			for(int i=0; i< Nodes.size(); i++)
			{
				MapNodes.put(Nodes.get(i).Number, Nodes.get(i));
			}
		}
		else if (typeNode==2)  // options
		{
			Root = root;
			MapNodes = new HashMap<Integer, ItemDataNode>();
			
			WcfOperations wcf = new WcfOperations();
			
			Nodes = wcf.GetArticleOptions(root,idLine, piece, fromMenu);
			
			for(int i=0; i< Nodes.size(); i++)
			{
				MapNodes.put(Nodes.get(i).Number, Nodes.get(i));
			}
		}
		else if (typeNode==3)  // pieces
		{
			Root = root;
			MapNodes = new HashMap<Integer, ItemDataNode>();
			
			WcfOperations wcf = new WcfOperations();
			
			Nodes = wcf.GetArticlePieces(root,idLine);
			
			for(int i=0; i< Nodes.size(); i++)
			{
				MapNodes.put(Nodes.get(i).Number, Nodes.get(i));
			}
		}
	}
	
	public ItemData(int root,int getOptionals) 
	{
		this(root, getOptionals, -1, -1, false);
	}
	
	public ItemDataNode GetArticle(int article)
	{
		ItemDataNode art = MapNodes.get(article);
		
		if (art!= null)
			return art;
		else
			return null;
	}
	
	public ItemDataNode GetArticleByPosition(int position)
	{
		try
		
		{
			ItemDataNode art = Nodes.get(position);
		
			if (art!= null)
				return art;
			else
				return null;
		}
		catch(Exception ex)
		{
			AndroidOperations.AppendLog("GetArticleByPosition:" + ex.getMessage());
			
			return null;	
		
		}
	}
	
	public byte [] GetImage(int position)
	{
		ItemDataNode it = Nodes.get(position);
		
		if (it!= null)
		{
			return Item.GetImage(it.Number);
		}
		else
			return null;
		
	}
	
	public byte [] GetImageByNumber(int position)
	{
		if (MapNodes==null )
			return null;
		
		ItemDataNode it = MapNodes.get(position);
		
		if (it!= null)
		{
			return Item.GetImage(it.Number);
		}
		else
			return null;
	}

	public byte[] GetImageRendered(int position)
	{
		ItemDataNode it = MapNodes.get(position);
		
		if (it!= null)
		{
			return Item.GetRenderImage(it.Number);
		}
		else
			return null;
	}
}
