package dst.net.droid;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import com.google.gson.Gson;

import dst.net.jsonObj.FreezeSalesOrderLine;
import dst.net.jsonObj.FreezeSalesOrderLineModifier;
import dst.net.jsonObj.FreezeSalesOrderLineOption;
import dst.net.jsonObj.GenericResult;
import dst.net.jsonObj.ItemDataNode;
import dst.net.rest.RestClient;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.GridView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class MenuActionHelperAct  extends Activity {

	public static  FreezeSalesOrderLineModifier[] CurrentModifiers = null;
	private LinearLayout dinerLayout;
	private Button btnDiner1,btnDiner2;
	private Button btnArticles,btnLines ;
	private FrameLayout _frameLines,_frameArticles; 
	private int _currentDiner;	
	private int _article;
	private String _articleName;
	private ListView _menuLines;
	private ArrayList<FreezeSalesOrderLine> _menuLinesAdapter;
	public ProgressDialog PDialog;
	private RegisterMenuLinesAdapter _regLines;
	private WcfOperations _wcf ;
	private AndroidOperations _andOP;
	private ImageMenuAdapter _menuAdapter ;
	public int CurrentPosition;

	public boolean AcceptArticleClicks;
	public Date LastArticleAdded;
	private Handler _handler;
	private Runnable _runnableDisableGrid;
	private int _waitMiliSeconds,_waitMiliSecondsToEnable;
	private Runnable _runnable;
	private ItemDataNode _selectedItem;
	public boolean AcceptMenu;
	private int _menuID,_piece;
	private TextView txtCurrentDiner;
	private double _price;
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
	
        setContentView(R.layout.menuhelperaction);
                
        Bundle extras = getIntent().getExtras();
        PDialog = new ProgressDialog(MenuActionHelperAct.this);
        
        _wcf =new WcfOperations();
        _article= extras.getInt("article",0);
        _articleName = extras.getString("articleName");
        _piece = extras.getInt("piece", -1);
        _price = extras.getDouble("price", 0);
        
        _currentDiner = -1;
        _andOP = new AndroidOperations(MenuActionHelperAct.this);
        AcceptArticleClicks = true;
        _handler = new Handler();
        LastArticleAdded = new Date();
        _waitMiliSeconds = 300;
        _waitMiliSecondsToEnable = 400;
        AcceptMenu = false;
        
        _runnable = new Runnable() 
    	{ 
    		public void run() 
    		{  
    			long seconds = new Date().getTime();
    			if (seconds - LastArticleAdded.getTime() > _waitMiliSeconds-50 && AcceptArticleClicks)
    			{
    				LastArticleAdded = new Date();
    			}
   			}
   		};
	
   		_runnableDisableGrid = new Runnable()
   		{ 
	   		public void run() 
	   		{  
	    			AcceptArticleClicks = true;
	   		}
   		};

		
        final TextView txtArticle = (TextView)findViewById(R.id.regtxtMenuArticleH);
        final Button btnCancel = (Button)findViewById(R.id.regbtnMenuCancelH);
        final Button btnQty = (Button)findViewById(R.id.menuActQtyH);
        final Button btnRemove = (Button)findViewById(R.id.menuActDeleteH);
        final Button btnModifiers = (Button) findViewById(R.id.menuActModH);
        final Button btnOptions = (Button) findViewById(R.id.menuActOptH);
        final Button btnAccept = (Button) findViewById(R.id.regbtnMenuOkH);
        
        btnAccept.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				AcceptMenu();
				
			}
		});
        
        btnModifiers.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				if (_menuLines.getItemAtPosition(_regLines.getPosition())!= null)
	    		{
					AskModifiers();
	    		}
	    		else
	    		{
	   	    		Toast.makeText(MenuActionHelperAct.this, R.string.SelectLine, Toast.LENGTH_SHORT).show();
	    		}
			}
		});
        
        btnOptions.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {

				
				if (_menuLines.getItemAtPosition(_regLines.getPosition())!= null)
	    		{
					AskOptionals();
	    		}
	    		else
	    		{
	   	    		Toast.makeText(MenuActionHelperAct.this, R.string.SelectLine, Toast.LENGTH_SHORT).show();
	    		}
			}
		});
        
        btnQty.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				if (_menuLines.getItemAtPosition(_regLines.getPosition())!= null)
	    		{
	    			EditAmount((FreezeSalesOrderLine)_menuLines.getItemAtPosition(_regLines.getPosition()));
	    		}
	    		else
	    		{
	   	    		Toast.makeText(MenuActionHelperAct.this, R.string.SelectLine, Toast.LENGTH_SHORT).show();
	    		}
			}
		});
        
        btnRemove.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				

				if (_menuLines.getItemAtPosition(_regLines.getPosition())!= null)
	    		{
					AskRemoveLine();
	    		}
	    		else
	    		{
	   	    		Toast.makeText(MenuActionHelperAct.this, R.string.SelectLine, Toast.LENGTH_SHORT).show();
	    		}
				
			}
		});
        
        btnCancel.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				setResult(RESULT_CANCELED);
				finish();
			}
		});
        
        btnArticles = (Button)findViewById(R.id.regbtnMenuArticlesH);
        btnLines = (Button)findViewById(R.id.regbtnMenuLinesH);
        _menuLines = (ListView) findViewById(R.id.menuLinesH);
        txtCurrentDiner = (TextView) findViewById(R.id.menuHelperCurrentDiner);
        
        
        int layout = R.layout.registeritemdiner;

       	AndroidOperations.OrderData.CurrentFreezeLines = new ArrayList<FreezeSalesOrderLine>();

       	_menuLinesAdapter = new ArrayList<FreezeSalesOrderLine>();
       	
       	List<FreezeSalesOrderLine> menulines = null;
       	
       	try
       	{
       		menulines = _wcf.StartMenuTransaction(_article,_piece);
       	}
       	catch (Exception e) {
       		AndroidOperations.AppendLog("StartMenuTransaction:" + e.getMessage());
       		setResult(RESULT_FIRST_USER);
       		finish();
       	}
       	
       	Iterator<FreezeSalesOrderLine> i = menulines.iterator();

    	while(i.hasNext())
    	{
    		FreezeSalesOrderLine l = (FreezeSalesOrderLine) i.next();
    		
    		_menuLinesAdapter.add(l);
    	}
       	
        _regLines = new RegisterMenuLinesAdapter(MenuActionHelperAct.this, layout, _menuLinesAdapter,true);
        
        _menuLines.setAdapter(_regLines);
        
        btnArticles.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				SetArticles(true);
			}
		});
        
        btnLines.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
			
				SetArticles(false);
			}
		});
        
        _frameLines = (FrameLayout)findViewById(R.id.regframeMenuLinesH);
        _frameArticles = (FrameLayout)findViewById(R.id.regframeMenuArticlesH);
        
        txtArticle.setText(_articleName);
        
        dinerLayout= (LinearLayout) findViewById(R.id.menuLinearDinersH);
        btnDiner1 = (Button) dinerLayout.getChildAt(0);
        btnDiner2 = (Button) dinerLayout.getChildAt(1);

        try 
        {
			_menuAdapter = new ImageMenuAdapter(true, _article ,MenuActionHelperAct.this);
			AndroidOperations.CurrentMenuAvailableDiners = _menuAdapter.GetAvailableDiners();
			
		} 
        catch (Exception e) {
			AndroidOperations.AppendLog("ImageMenuAdapter:" + e.getMessage());
       		setResult(RESULT_FIRST_USER);
       		finish();
		}
        
        SetButtonDinerEvents();
        
        ActivateDiner(1, true);
        
        SetArticles(true);
        
        if (menulines.size()>0)
        	btnLines.performClick();
	}
	
	private void AcceptMenu()
	{
		boolean makeQuestion = false;
		
        if (_menuLinesAdapter.size() >0)
        {
            AcceptMenu = true;

                double lastQty = -1;
                
                for (int i=0; i< AndroidOperations.CurrentMenuAvailableDiners.size(); i++)
                {              
                	int id = AndroidOperations.CurrentMenuAvailableDiners.get(i);
                    double qty = 0;;
                    
                    for (int j=0; j< _menuLinesAdapter.size(); j++)
                    {
                    	FreezeSalesOrderLine l = _menuLinesAdapter.get(j);
                    	
                    	if (l.MenuPart && id==l.CourseNumber)
                    	{
                    		qty+= l.Quantity;	
                    	}
                    }
                    
                    if (!Parameters.ECDinnerLastPlace[id-1] || qty != 0)
                    {
                       if (lastQty != -1 && lastQty != qty)
                        {
                        		i= AndroidOperations.CurrentMenuAvailableDiners.size();
                        		
                        		makeQuestion = true;
                        		
                            break;
                        }
                        else
                            lastQty = qty;
                    }
                }
            }
            
            if (makeQuestion)
            {
            	DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() { 
             		 
        		    public void onClick(DialogInterface dialog, int which) { 
        		        switch (which){ 
        		        case DialogInterface.BUTTON_POSITIVE: 
        		        	ConfirmMenu();
        		        	break;
        		        case DialogInterface.BUTTON_NEGATIVE:
        		        	
        		        	return;
        		        } 
        		    } 
        		}; 
        		 
        		AlertDialog.Builder builder = new AlertDialog.Builder(MenuActionHelperAct.this); 
        		builder.setIcon(R.drawable.ic_dialog_icon);
        		builder.setMessage(getString(R.string.MenuCourseIncomplete)).setPositiveButton(R.string.Yes, dialogClickListener) 
        		    .setNegativeButton(R.string.No, dialogClickListener).setCancelable(false).show();
            }
            else
            	ConfirmMenu();
        
	}
	
	private void ConfirmMenu()
	{
		try
		{
			_wcf.AddFreezeLine(_article, 1,_price, new ArrayList<Integer>(), new ArrayList<FreezeSalesOrderLineOption>(), _piece, -1, "", false, false, 0);
	
			
			for (int i=0; i< _menuLinesAdapter.size(); i++)
			{
				FreezeSalesOrderLine line = _menuLinesAdapter.get(i);
				
				String freeMod = line.TextFreeModifier;
				
				if (freeMod==null)
					freeMod="";
				
				AndroidOperations.OrderData.CurrentFreezeLines = _menuLinesAdapter;
			}
			
			_wcf.EndMenuTransaction(_article);
		}
		catch (Exception e) 
		{
       		AndroidOperations.AppendLog("ConfirmMenu:" + e.getMessage());
       		setResult(RESULT_FIRST_USER);
       		finish();
       	}
		
		setResult(RESULT_OK);
		finish();
		
	}

	public void EditAmount(FreezeSalesOrderLine l )
    {
    	try
    	{
   		
    		if (l!=null)
    		{
    			RestClient clientRest = new RestClient(Parameters.WcfUrl);
				Map<String, String> params = new HashMap<String, String>();
						
				params.put("deviceid", AndroidOperations.DeviceID);
				params.put("permissionid",String.valueOf(TypePermissions.PER_CHANGE_AMOUNT));
						
				try 
				{
					String response = clientRest.webGet("GetPermission/", params); 
						
					GenericResult resp = new Gson().fromJson(response, GenericResult.class);
							
					int respPerm = CheckPermission(resp, 2);
						
					switch (respPerm)
					{
						case 1: DoChangeQuantityActivity(l.Quantity); break;
						case -1:
						{
							
							_andOP = new AndroidOperations(MenuActionHelperAct.this);
							_andOP.ShowMessage(getString(R.string.Permissions),getString(R.string.AccessDenied)); break;
						}
					}
				}
				catch(Exception ex)
				{
					AndroidOperations.AppendLog("EditMenuAmount:" + ex.getMessage());
					
					setResult(RESULT_FIRST_USER);
					finish();
				}
    		}
    		else
    		{
    			_andOP = new AndroidOperations(MenuActionHelperAct.this);
    			_andOP.ShowMessage(getString(R.string.Error) ,getString(R.string.ShowRegisterChangeQtyError));
    		}
    	}
    	catch (Exception ex)
    	{
    		_andOP = new AndroidOperations(MenuActionHelperAct.this);
    		_andOP.ShowMessage(getString(R.string.Error ),getString(R.string.ShowRegisterChangeQtyError));	
    	}
    }
	
	public int CheckPermission(GenericResult result, int action)
	{

		if (result.Result==1 || result.Result==-1)
			return result.Result;
		
		//Show Table Form
        Intent i = new Intent(MenuActionHelperAct.this,  RequestAccessPasswordAct.class);
        
        i.putExtra("password", result.Description);
        i.putExtra("action", action);
        
        startActivityForResult(i,1);
        
        return 0;
	}

	private void SetArticles(boolean showArticles)
	{
		if (showArticles)
		{
			btnArticles.setEnabled(false);
			btnLines.setEnabled(true);
			_frameArticles.setVisibility(View.VISIBLE);
			_frameLines.setVisibility(View.INVISIBLE);
		}
		else
		{
			btnLines.setEnabled(false);
			btnArticles.setEnabled(true);
			_frameLines.setVisibility(View.VISIBLE);
			_frameArticles.setVisibility(View.INVISIBLE);
		}
	}
	
	private void SetButtonDinerEvents()
	{
		btnDiner1.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				ActivateDiner(_currentDiner-1, false);
			}
		});
		
		btnDiner2.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				ActivateDiner(_currentDiner+1, true);
			}
		});
	}
	
	private void ActivateDiner(int nextdiner, boolean next)
	{
		int i = nextdiner;
		
		while(i>0 && i <= Parameters.ECDinnerPassNames.length )
		{
			if (Parameters.ECDinnerPassNames[i-1].length()>0 && AndroidOperations.CurrentMenuAvailableDiners.contains(i))
			{
				_currentDiner = i;
				
				GridView gridMenuArt = (GridView)findViewById(R.id.gridviewMenuArticlesH);
		        
				_menuAdapter.ApplyDinerfilter(_currentDiner);
		        gridMenuArt.setAdapter(_menuAdapter);
		        
		        
		        txtCurrentDiner.setText(Parameters.ECDinnerPassNames[i-1]);
		        
		        if (i==AndroidOperations.CurrentMenuAvailableDiners.get(0))
		        	btnDiner1.setEnabled(false);
		        else
		        	btnDiner1.setEnabled(true);
		        
		        if (i==AndroidOperations.CurrentMenuAvailableDiners.get(AndroidOperations.CurrentMenuAvailableDiners.size()-1))
		        	btnDiner2.setEnabled(false);
		        else
		        	btnDiner2.setEnabled(true);
		        
		        return;
			}
			else
			{
				if (next)
					i++;
				else
					i--;
			}
		}
	}

	public void onActivityResult(int requestCode, int resultCode, Intent intent) 
	{
		if (PDialog!= null) 
			PDialog.dismiss();

		if (resultCode== RESULT_FIRST_USER)
    	{
			AndroidOperations.AppendLog("BackToMain FROM:" + this.toString());
			
    		setResult(RESULT_FIRST_USER);
    		finish();
    		return;
    	}
		
        if (requestCode == 0) 	//Change Qty
        { 
                 if (resultCode == RESULT_OK)
                 {
                     double newQty = intent.getDoubleExtra("newQty", 1);
                    
                     int position =_regLines.getPosition();
                     
                    FreezeSalesOrderLine l = (FreezeSalesOrderLine)_menuLines.getItemAtPosition(position);

                   	l.Quantity = newQty;	
               	
                   	try
                   	{
                   		_wcf.ChangeMenuQuantity(l.IdLine, newQty);
                   	}
                   	catch (Exception e) {
                   		AndroidOperations.AppendLog("EditAmountResult:" + e.getMessage());
                   		setResult(RESULT_FIRST_USER);
                   		finish();
                   	}
                   	
                 	_regLines.notifyDataSetChanged();
                 }
        }
        else if (requestCode == 1) //Return from ask Password
        {
        	if (resultCode == RESULT_OK)
        	{
      		
        		Bundle extras = intent.getExtras();
                
                int action = extras.getInt("action", 0);
        		
                if (action==1)
                	RemoveLineAction();
              
                else if (action ==2)
                	DoChangeQuantityActivity(0);
 
        	}
        }
        else if (requestCode == 3) //Return Ask Modifiers
        {
        	 if (resultCode == RESULT_OK)
             {
 
        		 if (_selectedItem!= null)
        		 { 
        			 
        			 ArrayList<Integer> modifiersSelected = intent.getIntegerArrayListExtra("modifiers");
        			 ArrayList<String> modifiersStrSelected = intent.getStringArrayListExtra("modifiersString");
        			 
        			 int lineID = intent.getIntExtra("idLine", -1); //if -1 i have to add line, esle its a update
        			 
       				 int index = modifiersSelected.indexOf(-1);
        				 
   				 Log.i("getView()", "UpdateModifiers_Start"); 
   				 String freeModText = "";
   				 
   				 if (index >-1)
   					 freeModText =  modifiersStrSelected.get(index);
   					 
   					
   				 try
   				 {
   					 _wcf.UpdateMenuModifiers(lineID, modifiersSelected,freeModText );
   				 }
   				 catch (Exception e) {
   					 
   					 AndroidOperations.AppendLog("UpdateMenuModifiers:" + e.getMessage());
   					 
   					 setResult(RESULT_FIRST_USER);
   					 finish();
					}
       				 
       				 
       				 FreezeSalesOrderLine line =  _menuLinesAdapter.get(lineID);
        				 
       				 line.Modifiers = new FreezeSalesOrderLineModifier[modifiersSelected.size()];
        					

       				 for (int j=0; j< modifiersSelected.size(); j++)
        			 {
        				 FreezeSalesOrderLineModifier l = new FreezeSalesOrderLineModifier();
        			    		
        				 l.Modifier = modifiersSelected.get(j);
        				 l.Description = modifiersStrSelected.get(j);
        				 
        				 line.Modifiers[j] = l;
        			 }
        			 
        			 _regLines.notifyDataSetChanged(); 
          			 
        			 _selectedItem = null;
        			 
        			 AcceptArticleClicks = false;
        			 ActivateGridDelayed();
        		 }
             }
        }
        else if (requestCode ==4)
        {
        	if (resultCode == RESULT_OK)
            {
        		 if (_selectedItem!= null)
        		 { 
        			 int lineID = intent.getIntExtra("idLine", -1); //if -1 i have to add line, esle its a update
        			 String newDescription = intent.getStringExtra("newdescription");
        			 double newPrice = intent.getDoubleExtra("newPrice",0);
        			 
       				FreezeSalesOrderLine line =  /*GetFreezeLineWithID(lineID);*/_menuLinesAdapter.get(lineID);
       				 
       				try
       				{
       				 _wcf.UpdateMenuOptionals(line.IdLine, Parameters.OptionsArticle);
       				}
       				catch (Exception e) {
   					 
   					 AndroidOperations.AppendLog("UpdateMenuHOptionals:" + e.getMessage());
   					 
   					 setResult(RESULT_FIRST_USER);
   					 finish();
					}

        				 
       				 ArrayList<FreezeSalesOrderLineOption> lstOpt = UpdateOptions(lineID);
	        				 
       				 line.Description = newDescription;
       				 line.Options= new FreezeSalesOrderLineOption[lstOpt.size()];
       				 line.Price = newPrice;
	        				 
       				 Iterator<FreezeSalesOrderLineOption> i = lstOpt.iterator();
	
	        				 int j=0;
	        				 
	        				 while(i.hasNext())
	        				 {
	        					 FreezeSalesOrderLineOption l = (FreezeSalesOrderLineOption) i.next();
	        			    		
	        					 line.Options[j] = l;
	        					 j++;
	        				 }

	        				 if (line.MultiOptionals!=1 && line.Options.length >0)
	        				 {
	        					 line.SetZeroPriceOptions();
	        				 }
	        				 
	        				 _regLines.notifyDataSetChanged(); 
        				 
        				 _selectedItem = null;
        				 
        				 if (Parameters.OptionsArticle!= null)
        					 Parameters.OptionsArticle.clear();
        			 }
        			 
        			 AcceptArticleClicks = false;
        			 ActivateGridDelayed();
        		 }
            }
	    	else if (requestCode ==5)
	    	{
	    		if (resultCode == RESULT_OK)
	            {
	    			int newCourse = intent.getIntExtra("newCourse", 1);
	                    
	    			FreezeSalesOrderLine l = (FreezeSalesOrderLine)_menuLines.getItemAtPosition(_regLines.getPosition());
	
	    			l.CourseNumber = newCourse;
	                 	
	    			try
	    			{
	    				
	    				_wcf.wcf_DoChangeMenuCourse(_regLines.getPosition(), newCourse);
	                 	
	    				_regLines.notifyDataSetChanged();
	                 	
	    				AcceptArticleClicks = false;
	    				ActivateGridDelayed();
	    			}
	    			catch (Exception e) 
	    			{
	    				AndroidOperations.AppendLog("ChangeCourseMenuHResult:" + e.getMessage());
	        				
	    				setResult(RESULT_FIRST_USER);
	    				finish();
	    			}
	            }
	    	
	    	} else
        	{
        		AcceptArticleClicks = true;
        	}
	}
	
	private ArrayList<FreezeSalesOrderLineOption> UpdateOptions(int maxID)
	{
		ArrayList<FreezeSalesOrderLineOption> optList  =new  ArrayList<FreezeSalesOrderLineOption>();
		
		for (int i=0; i< Parameters.OptionsArticle.size(); i++)
		{
			FreezeSalesOrderLineOption optionLine = new FreezeSalesOrderLineOption();
			
			optionLine.IdLine = maxID;
			optionLine.Number= i;
			optionLine.Article = Parameters.OptionsArticle.get(i).Article;
			optionLine.Description = Parameters.OptionsArticle.get(i).Description;
			optionLine.Price= Parameters.OptionsArticle.get(i).Price;
			
			optList.add(optionLine);
		}
		
		return  optList;
	}

    
	private void DoChangeQuantityActivity(double quantity)
    {
    	Intent i = new Intent(MenuActionHelperAct.this, AskQuantityAct.class);

        i.putExtra("quantity", quantity);

        startActivityForResult(i, 0);	
    }
    
    private void AskRemoveLine()
    {
    	if (_regLines.getPosition() < _regLines.getCount() &&  _menuLines.getItemAtPosition(_regLines.getPosition())!= null)
		{
    		
    		FreezeSalesOrderLine line  = (FreezeSalesOrderLine)(FreezeSalesOrderLine)_menuLines.getItemAtPosition(_regLines.getPosition());
    		
    		if (!line.PrintedInKitchen)
    		{
    			RestClient clientRest = new RestClient(Parameters.WcfUrl);
    			Map<String, String> params = new HashMap<String, String>();
    			
    			params.put("deviceid", AndroidOperations.DeviceID);
    			params.put("permissionid",String.valueOf(TypePermissions.PER_DELETE_LINE));
    			
    			try 
    			{
    				String response = clientRest.webGet("GetPermission/", params); 
    			
    				GenericResult resp = new Gson().fromJson(response, GenericResult.class);
    			
    				switch (CheckPermission(resp, 1))
    				{
    				case 1: RemoveLineAction(); break;
    				case -1:{
    						_andOP = new AndroidOperations(MenuActionHelperAct.this);
    						_andOP.ShowMessage(getString(R.string.Permissions),getString(R.string.AccessDenied)); break;
    						}
    				}
    			}
    			catch(Exception ex)
    			{
    				AndroidOperations.AppendLog("AskRemoveLine:" + ex.getMessage());
    				setResult(RESULT_FIRST_USER);
    				finish();
    				return;
    			}
    		}
    		else
    		{
    			CheckDeleteLinePrinted();
    		}
    		
    		
		}
    	else
    	{
    		Toast.makeText(MenuActionHelperAct.this, R.string.SelectLine, Toast.LENGTH_SHORT).show();
    	}
    }
    
   
    private void CheckDeleteLinePrinted()
    {
    	RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("permissionid",String.valueOf(TypePermissions.PER_DELETE_LINE_AK));
		
		try
		{
			String response = clientRest.webGet("GetPermission/", params); 
			
			GenericResult resp = new Gson().fromJson(response, GenericResult.class);
			
			switch (CheckPermission(resp, 2))
			{
				case 1: RemoveLineAction(); break;
				
				case -1:{
					_andOP = new AndroidOperations(MenuActionHelperAct.this);
					_andOP.ShowMessage(getString(R.string.Permissions),getString(R.string.AccessDenied)); break;
				}
			}
		}
		catch (Exception ex)
		{
			AndroidOperations.AppendLog("CheckDeleteLinePrinted:" + ex.getMessage());
			
			setResult(RESULT_FIRST_USER);
			finish();
		}
    }
	
    
    private void RemoveLineAction()
    {
    	DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() { 
    		
    		public void onClick(DialogInterface dialog, int which) { 
		        switch (which){ 
		        case DialogInterface.BUTTON_POSITIVE: 
		        	RemoveLineActionStep2(); 
		            break; 
		 
		        case DialogInterface.BUTTON_NEGATIVE: 
		            break; 
		        } 
		    } 
		}; 
		 
		AlertDialog.Builder builder = new AlertDialog.Builder(MenuActionHelperAct.this); 
		builder.setIcon(R.drawable.ic_dialog_icon);
		builder.setMessage(R.string.ShowRegisterAskRemoveLine).setPositiveButton(R.string.Yes, dialogClickListener) 
		    .setNegativeButton(R.string.No, dialogClickListener).setCancelable(false).show();
    }
    
    
    private void RemoveLineActionStep2()
    {
    	if (_menuLines.getItemAtPosition(_regLines.getPosition())!= null)
		{
			//REMOVE ON GRID
    		
    		FreezeSalesOrderLine lineToDelete = (FreezeSalesOrderLine)_menuLines.getItemAtPosition(_regLines.getPosition());

			//REMOVE WEB SERVICE
			RestClient clientRest = new RestClient(Parameters.WcfUrl);
			Map<String, String> params = new HashMap<String, String>();
			
			
			params.put("deviceid", AndroidOperations.DeviceID);
			params.put("lineNumber",String.valueOf(_regLines.getPosition()/*lineToDelete.IdLine*/));

			try     
			{
				String response = clientRest.webGet("DeleteMenuLine/", params); 
				
				GenericResult resp = new Gson().fromJson(response, GenericResult.class);
				
				if (!resp.SerialIdOk)
				{
					setResult(RESULT_FIRST_USER);
					finish();
				}
				
				_regLines.remove(lineToDelete);
				
				_regLines.notifyDataSetChanged();
				
				AndroidOperations.OrderData.SaleLines.remove(lineToDelete.IdLine);

			}
			catch (Exception e) 
			{
				AndroidOperations.AppendLog("RemoveLineMenuActionStep2:" + e.getMessage());
				
				setResult(RESULT_FIRST_USER);
				finish();
			}
		}	
    }
    
    
    public void ActivateGridDelayed()
    {
    	_handler.postDelayed(_runnableDisableGrid, _waitMiliSecondsToEnable);
    }
    
    
    public void EventDataClick(ItemDataNode idItem, ImageView image, int amount, boolean focuseLine) 
    {
    	if (!AcceptArticleClicks)
    		return;
    	
    	try
    	{
	    	GenericResult res = _wcf.AddMenuLine(idItem.Number, 1, idItem.GetCurrentPrice(), -1,"", "", "", idItem.CourseNumber);
	    	
			MakeAddMenuLine(res.Result,idItem,amount,  new ArrayList<Integer>(),new ArrayList<String>(), Parameters.OptionsArticle,focuseLine);
    	}
    	catch (Exception e) {
       		AndroidOperations.AppendLog("EventDataClick:" + e.getMessage());
       		setResult(RESULT_FIRST_USER);
       		finish();
       	}
    }
    
    private void MakeAddMenuLine(int index,  ItemDataNode idItem,int amount,  ArrayList<Integer> modifiers,ArrayList<String> modifiersStr,ArrayList<FreezeSalesOrderLineOption> options, boolean focuseLine)
	{
		LastArticleAdded = new Date();
		
		FreezeSalesOrderLine line = new FreezeSalesOrderLine(_menuLinesAdapter.size(), idItem,amount);

		//GetModifiers
		line.Modifiers = new FreezeSalesOrderLineModifier[modifiers.size()];
		line.MultiOptionals = idItem.MultiOptionals;
		line.Description = idItem.TicketText;
		line.Piece = /*idItem.Piece*/ _piece;
		line.IdLine = index;
    	line.MenuPart = true;
    	line.CourseNumber = idItem.CourseNumber;
    	line.Menu = _menuID;
    	
		for (int j=0; j< modifiers.size(); j++)
    	{
			if (modifiers.get(j)==-1)
			{
				line.TextFreeModifier = modifiersStr.get(j);
			}
			
			FreezeSalesOrderLineModifier l = new FreezeSalesOrderLineModifier();
	    		
			l.Description = modifiersStr.get(j);
			l.Modifier = modifiers.get(j);

			line.Modifiers[j] = l;
    	}
		
		/*** OPTIONS   ***********/
		if (options!=null)
		{
			line.Options = new FreezeSalesOrderLineOption[options.size()];
					
			Iterator<FreezeSalesOrderLineOption> k = options.iterator();
	
			int q=0;
			while(k.hasNext())
			{
				FreezeSalesOrderLineOption l = (FreezeSalesOrderLineOption) k.next();
			    		
				if (idItem.PriceChanged)
					l.Price = 0;

				if (line.MultiOptionals !=1)
				{
					line.Price =  l.Price;
					l.Price =0;
				}
				
				l.Number= q;
			    line.Options[q] = l;
			    q++;
			}
		}
		/**********/
		
		_menuLinesAdapter.add(line);

		 if (Parameters.OptionsArticle!= null)
				Parameters.OptionsArticle.clear();
		 
		 _regLines.notifyDataSetChanged();
		 
		_handler.postDelayed(_runnable, _waitMiliSeconds);
	}
    
    private void AskModifiers()
    {
    	Intent i = new Intent(MenuActionHelperAct.this, ModifiersSelectAct.class);
    	
    	if ((FreezeSalesOrderLine)_menuLines.getItemAtPosition(_regLines.getPosition())== null)
    		return;
		
    	PDialog.setMessage(getText(R.string.Processing)); 
		PDialog.setIndeterminate(true);
		PDialog.setCancelable(false);
		PDialog.show();
    	
		FreezeSalesOrderLine line  = (FreezeSalesOrderLine)_menuLines.getItemAtPosition(_regLines.getPosition());
    	
    	_selectedItem  = new ItemDataNode();
    	_selectedItem.Number = line.Article;
    	
    	CurrentModifiers = line.Modifiers;
    	
    	i.putExtra("idLine",_regLines.getPosition());
    	i.putExtra("article", _selectedItem.Number);
    	i.putExtra("articlename",line.Description);
    	i.putExtra("fromMenu",true);
    	
		startActivityForResult(i, 3);
    }
    
    private void AskOptionals()
    {
    	if ((FreezeSalesOrderLine)_menuLines.getItemAtPosition(_regLines.getPosition())== null )
		return;
		
		FreezeSalesOrderLine line  = (FreezeSalesOrderLine)_menuLines.getItemAtPosition(_regLines.getPosition());

    	PDialog.setMessage(getText(R.string.Processing)); 
    	PDialog.setCancelable(false);
		PDialog.setIndeterminate(true); 
		PDialog.show(); 
    	
    	ItemDataNode item = null;
    	
    	try
    	{
    		item = _wcf.GetArticleInfo(line.Article);
    	}
    	catch (Exception e) {
       		AndroidOperations.AppendLog("AskOptionals:" + e.getMessage());
       		setResult(RESULT_FIRST_USER);
       		finish();
       	}
    	
    	if (!item.HasChildsOptions)
    	{
    		_andOP.ShowMessage(MenuActionHelperAct.this , getString(R.string.Options), getString(R.string.OptionsNoArticle));
    		PDialog.dismiss();
    		return;
    	}
    	
    	Intent i;
    	if (line.MultiOptionals==1)
   			i = new Intent(MenuActionHelperAct.this, MultiOptionalAct.class);
    	else
   			i = new Intent(MenuActionHelperAct.this, SingleOptionalAct.class);
    	
    		
    	_selectedItem  = new ItemDataNode();
    	_selectedItem.Number = line.Article;
    	_selectedItem.SetPrice(AndroidOperations.CurrentTableTariff, line.Price);
    	_selectedItem.MultiOptionals = line.MultiOptionals;
    	
    	i.putExtra("idLine",  _regLines.getPosition()); 
    	i.putExtra("article", _selectedItem.Number);
    	i.putExtra("price", _selectedItem.GetCurrentPrice());
    	i.putExtra("articleDescription", line.Description);
    	i.putExtra("multioptional", line.MultiOptionals);
    	i.putExtra("inmenu", true);
    	
    	if (Parameters.OptionsArticle==null)
    		Parameters.OptionsArticle = new ArrayList<FreezeSalesOrderLineOption>();
    	
    	Parameters.OptionsArticle.clear();
    	
    	for (int j=0; j< line.Options.length; j++)
    	{
    		Parameters.OptionsArticle.add(line.Options[j]);
    	}
    	
		startActivityForResult(i, 4);
    	
    	
    }
    
    public void ChangeCourse()
    {
    	try
    	{
    		
    		if (_menuLines.getItemAtPosition(_regLines.getPosition())== null)
    		{
    			_andOP = new AndroidOperations(MenuActionHelperAct.this);
    			_andOP.ShowMessage(getString(R.string.Error) ,getString(R.string.ShowRegisterChangeQtyError));
    			
    		}
    		else
    		{
		        DoChangeCourse();
    		}
    	}
    	catch (Exception ex)
    	{
    		_andOP = new AndroidOperations(MenuActionHelperAct.this);
    		_andOP.ShowMessage(getString(R.string.Error ),getString(R.string.ShowRegisterChangeQtyError));	
    	}
    }
    
    private void DoChangeCourse()
    {
    	Intent i = new Intent(MenuActionHelperAct.this, SelectDinnerPassAct.class);

        startActivityForResult(i, 5);	
    }
}
