package dst.net.droid;


import java.io.UnsupportedEncodingException;
import java.util.List;

import dst.net.jsonObj.FreezeSalesOrderLineModifier;
import dst.net.jsonObj.ItemDataModifier;

import android.content.Context;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.ToggleButton;

public class ModifiersAdapter extends BaseAdapter 
{    
	private Context mContext;
	private List<ItemDataModifier> _modifierList;
	private AndroidOperations _andOP;
	private String _freeText;
	
	public ModifiersAdapter(int article, int lineID, Context c,boolean fromMenu) throws UnsupportedEncodingException 
	{
		System.gc();
  
		mContext = c;
		_andOP = new AndroidOperations(c);
		
		try
		{
			WcfOperations wcf = new WcfOperations();
			
			if (!fromMenu)
			{
				_modifierList = wcf.GetModifiers(article, lineID, fromMenu);
				
				_freeText ="";
				
				if (_modifierList.get(0).Modifier==-1)
				{
					_freeText = _modifierList.get(0).Description;
					_modifierList.get(0).Description = mContext.getString(R.string.FreeText);
				}
			}
			else
			{
				_modifierList = wcf.GetModifiers(article, lineID, fromMenu);
				
				_freeText ="";
				
				if (_modifierList.get(0).Modifier==-1)
				{
					_freeText = _modifierList.get(0).Description;
					_modifierList.get(0).Description = mContext.getString(R.string.FreeText);
				}
				
				if (!Parameters.TCMenuCourseControl)
				{
					for (int i=0; i< MenuActionAct.CurrentModifiers.length; i++)
					{
						FreezeSalesOrderLineModifier mod;
						
						mod = MenuActionAct.CurrentModifiers[i];
						
						if(mod.Modifier==-1)
						{
							if (_modifierList.get(0).Modifier==-1)
							{
								_freeText =mod.Description;
								_modifierList.get(0).Selected= true;
							}
						}
						else
						{
							for (int j=0; j< _modifierList.size(); j++)
							{
								ItemDataModifier tmp = _modifierList.get(j);
								
								if (tmp.Modifier == mod.Modifier)
								{	
									tmp.Selected = true;
									break;
								}
								
							}
						}
					}
				}
				else
				{
					for (int i=0; i< MenuActionHelperAct.CurrentModifiers.length; i++)
					{
						FreezeSalesOrderLineModifier mod;
						
						mod = MenuActionHelperAct.CurrentModifiers[i];
						
						
						if(mod.Modifier==-1)
						{
							if (_modifierList.get(0).Modifier==-1)
							{
								_freeText =mod.Description;
								_modifierList.get(0).Selected= true;
							}
						}
						else
						{
							for (int j=0; j< _modifierList.size(); j++)
							{
								ItemDataModifier tmp = _modifierList.get(j);
								
								if (tmp.Modifier == mod.Modifier)
								{	
									tmp.Selected = true;
									break;
								}
							}
						}
					}	
				
				}
			}
				
			_modifierList.get(0).Description = mContext.getString(R.string.FreeText);
		}
		catch (Exception ex)
		{
			
		}
	} 
	public int getCount() 
	{       
		return _modifierList.size();
	}  
	public Object getItem(int position)
	{       
		return _modifierList.get(position); 
	}   
	public long getItemId(int position)
	{     
		return _modifierList.get(position).Modifier;
	}  
	
	// create a new ImageView for each item referenced by the Adapter 
	public View getView(final int position, View convertView, final ViewGroup parent) 
	{     
        ToggleButton buttonView= null;        
        
        Log.i("getView()", "GETTING VIEW_POSITION[" + String.valueOf(position) + "]" + (convertView != null?convertView.toString():"null")); 
 
        final ItemDataModifier mo =_modifierList.get(position); // (ItemDataNode) getItem(position);
        
        if (convertView == null) 
        {

	        	buttonView = new ToggleButton(mContext);
	        	buttonView.setPadding(2,2,2,2);
	        	buttonView.setHeight(_andOP.GetRealPixel(70));
	        	buttonView.setGravity(Gravity.TOP | Gravity.CENTER);
	        	
	        	if (mo.Modifier>0)
	        	{
	        		buttonView.setText(mo.Description);
	        		buttonView.setTextOn(mo.Description);
		        	buttonView.setTextOff(mo.Description);
	        	}
	        	else
	        	{
	        		buttonView.setText(mContext.getString(R.string.FreeText));
	        		buttonView.setTextOn(mContext.getString(R.string.FreeText));
		        	buttonView.setTextOff(mContext.getString(R.string.FreeText));
	        	}
		        	
	        	buttonView.setTag(mo.Modifier);
	        	
	        	if (mo.Selected || ModifiersSelectAct.SelectedModifiers.contains(mo.Modifier))
	        	{
	        		buttonView.setChecked(true);
	        		if (!ModifiersSelectAct.SelectedModifiers.contains(mo.Modifier))
	        		{
	        			ModifiersSelectAct.SelectedModifiers.add(mo.Modifier);
	        			ModifiersSelectAct.SelectedModifiersStr.add(mo.Description);
	        		}
	        		
	        		if (mo.Modifier==-1)
	        		{
	        			LinearLayout viewParent =(LinearLayout) parent.getParent();
						LinearLayout p = (LinearLayout) viewParent.getChildAt(0);
						TextView t = (TextView) p.getChildAt(0);
						
						p.setVisibility(View.VISIBLE);
						
						if (_freeText.length()>0  && t.getText().length()==0)
							t.setText(_freeText);
						
	        		}
	        	}
	        	else
	        	{
	        		if (ModifiersSelectAct.SelectedModifiers.contains(mo.Modifier))
	        		{
	        			ModifiersSelectAct.SelectedModifiers.remove(mo.Modifier);
	        			ModifiersSelectAct.SelectedModifiersStr.remove(mo.Description);
	        		}
	        	}
        }  
        else  //Cached Image
        {            
        	
	        	buttonView = new ToggleButton(mContext);
     	       
	        	buttonView.setPadding(2,2,2,2);
	        	buttonView.setHeight(_andOP.GetRealPixel(70));
	        	buttonView.setGravity(Gravity.TOP | Gravity.CENTER);
	        	buttonView.setText(mo.Description);
	        	buttonView.setTextOn(mo.Description);
	        	buttonView.setTextOff(mo.Description);
	        	buttonView.setTag(mo.Modifier);
	        	
	        	LinearLayout viewParent =(LinearLayout) parent.getParent();
	        	LinearLayout p = (LinearLayout) viewParent.getChildAt(0);
	        	
	        	if (ModifiersSelectAct.SelectedModifiers!=null)
	        	{
		        	if (mo.Selected || ModifiersSelectAct.SelectedModifiers.contains(mo.Modifier))
		        	{
		        		buttonView.setChecked(true);
		        		if (!ModifiersSelectAct.SelectedModifiers.contains(mo.Modifier))
		        		{
		        			ModifiersSelectAct.SelectedModifiers.add(mo.Modifier);
		        			ModifiersSelectAct.SelectedModifiersStr.add(mo.Description);
		        		}
		        		
		        		if (mo.Modifier==-1)
		        			p.setVisibility(View.VISIBLE);
		        		
		        	}
		        	else
		        	{
		        		if (ModifiersSelectAct.SelectedModifiers.contains(mo.Modifier))
		        		{
		        			ModifiersSelectAct.SelectedModifiers.remove(mo.Modifier);
		        			ModifiersSelectAct.SelectedModifiersStr.remove(mo.Description);
		        		}
		        		
		        		if (mo.Modifier==-1)
		        			p.setVisibility(View.INVISIBLE);
		        	}
	        	}
        }    

        if (buttonView!=null)
	        buttonView.setOnClickListener(new OnClickListener() {
				
				public void onClick(View v) {
					
					final ToggleButton im = (ToggleButton) v;

					int modNumber = Integer.valueOf(im.getTag().toString());
					int index = getIndex(modNumber);
					
					if (modNumber!=-1)
					{
						
						if (im.isChecked())
						{
							if (index>-1)
								_modifierList.get(index).Selected = true;
							
							ModifiersSelectAct.SelectedModifiers.add(modNumber);
							ModifiersSelectAct.SelectedModifiersStr.add((String) im.getText());
						}
						else
						{
							if (index>-1)
								_modifierList.get(index).Selected = false;
							
							ModifiersSelectAct.SelectedModifiers.remove((Object) modNumber);
							ModifiersSelectAct.SelectedModifiersStr.remove((String) im.getText());
						}
					}
					else
					{
						
						LinearLayout viewParent =(LinearLayout) parent.getParent();
						LinearLayout p = (LinearLayout) viewParent.getChildAt(0);
						TextView t = (TextView) p.getChildAt(0);
						
						t.setText("");
						
						if (im.isChecked())
						{
							if (index>-1)
								_modifierList.get(index).Selected = true;
							
							
							ModifiersSelectAct.SelectedModifiers.add(modNumber);
							ModifiersSelectAct.SelectedModifiersStr.add("");
							p.setVisibility(View.VISIBLE);
							t.requestFocusFromTouch();
							AndroidOperations.showInputMethod((ModifiersSelectAct) mContext, t);
						}
						else
						{
							if (index>-1)
								_modifierList.get(index).Selected = false;
							
							p.setVisibility(View.INVISIBLE);
							
							AndroidOperations.hideInputMethod(((ModifiersSelectAct) mContext), t);
							
							
							ModifiersSelectAct.SelectedModifiers.remove(index);
							ModifiersSelectAct.SelectedModifiersStr.remove(index);
						}
					}
				}
			});
        
       	return buttonView;
	}

	private int getIndex(int modifier)
	{
		int index = -1;
		for (int i=0; i< _modifierList.size(); i++)
		{
			ItemDataModifier dm = _modifierList.get(i);
			
			if (dm.Modifier== modifier)
			{
				index = i;
				break;
			}
		}
		
		return  index;
	}
	
}

