package dst.net.droid;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;

import android.app.Activity;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.GridView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.TextView.OnEditorActionListener;

public class ModifiersSelectAct  extends Activity {
	
	private int _article;
	private int _idline;
	private String _articleName;
	private static TextView _textViewFree;
	
	private static GridView gridviewModifiers;
	private static ModifiersAdapter _modAdap;
	public static ArrayList<Integer> SelectedModifiers;
	public static ArrayList<String> SelectedModifiersStr;
	public static boolean _hasentered;
	private TextView _txtArticleName;
	private boolean _fromMenu;
		
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    
        setContentView(R.layout.askmodifiers);
        
        if (Parameters.VerticalMode)
       	 setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        
        if (SelectedModifiers==null)
        	SelectedModifiers = new ArrayList<Integer>();
        if (SelectedModifiersStr==null)
        	SelectedModifiersStr = new ArrayList<String>();
        
        Bundle extras = getIntent().getExtras();
        
        _article= extras.getInt("article",0);
        _idline = extras.getInt("idLine",-1);
        _articleName = extras.getString("articlename");
        _fromMenu = extras.getBoolean("fromMenu",false);
        
        
       	_txtArticleName = (TextView) findViewById(R.id.textModArticle);
        
        _txtArticleName.setText(_articleName);
        
        if (_modAdap==null)
			try
        	{
				_modAdap = new ModifiersAdapter( _article, _idline,  ModifiersSelectAct.this,_fromMenu);
			} 
			catch (UnsupportedEncodingException e1)
			{
				AndroidOperations.AppendLog("Modifiers_Select_Create:" + e1.getMessage());
				e1.printStackTrace();
			}
        
        	gridviewModifiers= (GridView)findViewById(R.id.modifiersGridView);
        	gridviewModifiers.setNumColumns(Parameters.ArticleColumns);
            
            gridviewModifiers.removeAllViewsInLayout();
            
            gridviewModifiers.setAdapter(_modAdap);

        	_textViewFree = (TextView) findViewById(R.id.modifierFreeText);
        
        AndroidOperations.hideInputMethod(ModifiersSelectAct.this, _textViewFree);


        final Button cancelButton = (Button) findViewById(R.id.modifiersCancel);
        
        cancelButton.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				 SelectedModifiers = null;
		         SelectedModifiersStr = null;
		         _modAdap= null;
		         _txtArticleName = null;
		         
		         
				setResult(RESULT_CANCELED);
				finish();
			}
		});
        
        final Button acceptButton = (Button) findViewById(R.id.modifiersAccept);
        
        acceptButton.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				Bundle bundle = new Bundle();
		        
	            bundle.putInt("idLine", _idline);
	            
	            if (_textViewFree.getText().length()> 0)
	            {
	            	if (!SelectedModifiers.contains(-1))
	        		{
	        			SelectedModifiers.add(-1);
	        			SelectedModifiersStr.add( String.valueOf(_textViewFree.getText()));
	        		}
	            	else
	            	{
	            		int index = SelectedModifiers.lastIndexOf(-1);
	            		SelectedModifiersStr.set(index, String.valueOf(_textViewFree.getText()));
	            	}
	            }
	            else
	            {
	            	int numFree= -1;
	            	if (SelectedModifiers.contains((Object)numFree))
	        		{
	            		int index = SelectedModifiers.indexOf(-1);
	            		SelectedModifiers.remove(index);
	            		SelectedModifiersStr.remove(index);
	        		}
	            }
	 
	            bundle.putIntegerArrayList("modifiers", SelectedModifiers);
	            bundle.putStringArrayList("modifiersString", SelectedModifiersStr);
	            bundle.putString("freeText", String.valueOf( _textViewFree.getText()));
	          
	            
	            _modAdap= null;
	            
	            Intent i = new Intent();
	            
	            i.putExtras(bundle);
	            setResult(RESULT_OK, i);
	            finish();
	            
	            SelectedModifiers = null;
	            SelectedModifiersStr = null;
	            
	            AndroidOperations.hideInputMethod(ModifiersSelectAct.this, _textViewFree);
			}
		});
	
        LinearLayout lin = (LinearLayout) findViewById(R.id.modlinearLayoutTitle);
        
        lin.requestFocus();
        
        if (SelectedModifiers.contains(-1))
        {	
        	if (!_hasentered)
        	{
        		_textViewFree.setText(SelectedModifiersStr.get(0));
        		_hasentered= true;
        	}
        
        	LinearLayout viewParent =(LinearLayout) findViewById(R.id.askModFreeText);
			viewParent.setVisibility(View.VISIBLE);
        }else
        {
        	if (!_hasentered)
        	{
        		_hasentered= true;
        	}
        }
        
        _textViewFree.setOnEditorActionListener(new OnEditorActionListener() {
			
			public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
				// TODO Auto-generated method stub
				
				  AndroidOperations.hideInputMethod(ModifiersSelectAct.this, v);
	            return true; 
			}
		}); 
	}

	@Override 
	public void onBackPressed() { 
		
		 SelectedModifiers = null;
         SelectedModifiersStr = null;
         _modAdap= null;
         _txtArticleName= null;
         
         
		setResult(RESULT_CANCELED);
		finish();

	} 
	
    @Override 
    protected void onResume() 
    { 
        super.onResume(); 
     
        if (_textViewFree!= null)
        {
        	AndroidOperations.hideInputMethod(ModifiersSelectAct.this, _textViewFree);
        }

    } 
}
