package dst.net.droid;

import java.util.ArrayList;

import dst.net.jsonObj.ItemDataNode;

import android.app.Activity;
import android.content.Context;
import android.content.res.Resources;
import android.graphics.Color;
import android.util.TypedValue;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

public class OptionsSelectedAdapter extends ArrayAdapter<ItemDataNode> {
	 
    private ArrayList<ItemDataNode> items;
    private Context _context;
    private int _selectedPos = -1;
    
    public OptionsSelectedAdapter(Context context, int textViewResourceId, ArrayList<ItemDataNode> items) {
             super(context, textViewResourceId, items);
             this.items = items;
             _context = context;
     }

    
    public int getPosition()
    {
    	return _selectedPos;
    }
    
    public void setSelectedPosition(int pos)
    {
    	_selectedPos = pos;
		// inform the view of this change
		notifyDataSetChanged();
	}

    @Override
     public View getView(int position, View convertView, ViewGroup parent) {
             
    	TextView v;
             
             if (convertView == null) {
            	 v = new TextView(_context);
            	 v.setTextSize(TypedValue.COMPLEX_UNIT_SP, 18);
            	 v.setTextColor(Color.WHITE);
             }
             else
            	 v = (TextView) convertView;
             
             ItemDataNode o = items.get(position);
  
             if (v != null) 
            	 v.setText(o.TicketText);                            
            	 
             if(_selectedPos == position)
             {	 
            	 Resources r = ((Activity) _context).getResources();
            	 v.setBackgroundColor(r.getColor(R.color.blueColor));
             }
             else
            	 v.setBackgroundColor(Color.BLACK);
             
             return v;
     }
}