package dst.net.droid;

import java.util.ArrayList;

import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.util.TypedValue;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

public class PayMethodsAdapter extends ArrayAdapter<String> {
	 
    private ArrayList<String> items;
    private Context _context;
    private int _selectedPos = -1;
    
    public PayMethodsAdapter(Context context, int textViewResourceId, ArrayList<String> items) {
             super(context, textViewResourceId, items);
             this.items = items;
             _context = context;
     }

    
    public int getPosition()
    {
    	return _selectedPos;
    }
    
    public String getItem(int position)
	{       
		return items.get(position); 
	} 
    
    public void setSelectedPosition(int pos){
    	_selectedPos = pos;
		// inform the view of this change
		notifyDataSetChanged();
	}

    @Override
     public View getView(int position, View convertView, ViewGroup parent) {
             
    	TextView v;
             
             if (convertView == null) {
            	 v = new TextView(_context);
            	 v.setTextSize(TypedValue.COMPLEX_UNIT_SP, 20);
            	 v.setTextColor(Color.WHITE);
             }
             else
            	 v = (TextView) convertView;
             
             
           	 if (v != null) 
           	 {
           		 v.setPadding(0, 5, 0, 5);
           		 
           		 v.setText(items.get(position));                            
             
	           	 if(_selectedPos == position)
	        		 v.setBackgroundColor(((Activity) _context).getResources().getColor(R.color.blueColor));
	        	 else
	        		 v.setBackgroundColor(Color.BLACK);
           	 }
           	 
             return v;
     }
}