package dst.net.droid;

import java.util.ArrayList;

import dst.net.jsonObj.PreOrderInfo;

import android.app.Activity;
import android.content.Context;
import android.graphics.Color;

import android.view.Display;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

public class RecoverOrderListAdapter extends ArrayAdapter<PreOrderInfo> {
	 
    private ArrayList<PreOrderInfo> items;
    private Context _context;
    private int _selectedPos = -1;
    int _totalWidth;
    
    public RecoverOrderListAdapter(Context context,  ArrayList<PreOrderInfo> items) {
             super(context, 0, items);
             this.items = items;
             _context = context;
             
             Display display = ((Activity) _context).getWindowManager().getDefaultDisplay();  
     		 _totalWidth = display.getWidth();
     }

    
    public int getPosition()
    {
    	return _selectedPos;
    }
    
    public PreOrderInfo gettSelectedString(){
    	
    	if (_selectedPos>-1)
    	{
    		return items.get(_selectedPos);
    		
    	}
    	else
    		return null;
	}
    
    
    public void setSelectedPosition(int pos){
    	_selectedPos = pos;
		// inform the view of this change
		notifyDataSetChanged();
	}

    @Override
     public View getView(final int position, View convertView, ViewGroup parent) {
             
    			View v = convertView; 
    			PreOrderInfo item = items.get(position);
          
             
             if(v == null){ 
                 LayoutInflater vi = (LayoutInflater)_context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);  
                 
                 	v = vi.inflate(R.layout.recoverorderitem, null);
             } 

             
             if (item != null)
             { 
                  final LinearLayout linDesc = (LinearLayout) v.findViewById(R.id.roLinDate);
                  final TextView txtPrice = (TextView) v.findViewById(R.id.roTxtAmount);
                  final TextView resDescription = (TextView) linDesc.getChildAt(0);
                  final TextView resQty = (TextView) v.findViewById(R.id.roTxtNumber); 
                  
                  //linDesc.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.WRAP_CONTENT));
 		        
                 if (resQty != null){
                	 
                	String mode = "K-"; 
                	 
                	if (item.OrderType!=0)
                		mode = "C-";
                	
                 	resQty.setText(mode + String.valueOf(item.TableId2)); 
                 	
                 	resQty.setOnClickListener(new OnClickListener() {
         				
         				public void onClick(View v) {
         					// TODO Auto-generated method stub
         					setSelectedPosition(position);
         					notifyDataSetChanged();
         				}
         			});
                 } 
  
                 if (resDescription != null)
                 { 
                	 
                 	resDescription.setText(item.OrderDate); 
                 	
                 	 linDesc.setOnClickListener(new OnClickListener() {
     					
     					public void onClick(View v) {
     					
     						setSelectedPosition(position);
     						notifyDataSetChanged();

     					}
     				});
                 	 
                 	resDescription.setOnClickListener(new OnClickListener() {
     					
     					public void onClick(View v) {
     					
     						setSelectedPosition(position);
     						notifyDataSetChanged();
     						
     					}
     				});
                 }  
                 
                 if (txtPrice != null){ 
                	 txtPrice.setText(Parameters.MoneyFormat.format(item.Amount) );  //Set Money Format WithoutSymbol 
                	 
                	 txtPrice.setOnClickListener(new OnClickListener() {
     					
     					public void onClick(View v) {

     						setSelectedPosition(position);
     						notifyDataSetChanged();
     					}
     				});
                  } 

                 if(_selectedPos == position)
            		 v.setBackgroundColor(Color.WHITE);
            	 else
            		 v.setBackgroundColor(Color.BLACK);
                 
                 v.requestLayout();
             }
             return v;            
             
             /*
             
             PreOrderInfo o = items.get(position);
             
             if (o != null) 
             {
            	 TextView tt = (TextView) v;
                     
            	 if (tt != null) 
            		 tt.setText(o.TableId2 + " " + o.Amount);                            
             }
             
             if(_selectedPos == position)
        		 v.setBackgroundColor(((Activity) _context).getResources().getColor(R.color.blueColor));
        	 else
        		 v.setBackgroundColor(Color.BLACK);
             
             return v;*/
     }
}