package dst.net.droid;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import dst.net.jsonObj.TableSubOrder;
import dst.net.rest.RestClient;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.Gravity;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.RadioButton;
import android.widget.RadioGroup;

public class RequestSubOrderAct extends Activity {
	
	private boolean _transferMode;
	private int _maxSubOrder;
	
	private  ProgressDialog PDialog;
	private boolean _pressed;
	private Handler _handler;
	
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        _pressed = false;

        PDialog = new ProgressDialog(RequestSubOrderAct.this);
        PDialog.setMessage(getText(R.string.Processing)); 
		PDialog.setIndeterminate(true); 
		PDialog.setCancelable(false);
		
		_handler=new Handler(){ 

			@Override
            public void handleMessage(Message msg) {

				_pressed = false;
			   PDialog.dismiss();
			}
		}; 
        
        
        setContentView(R.layout.requestsuborder);
        
        final Button newButon = (Button) findViewById(R.id.subrdNew);
        final Button selectButon = (Button) findViewById(R.id.subrdOK);
        final Button backtButon = (Button) findViewById(R.id.subrBack);
        
        
        Bundle extras = getIntent().getExtras();
        _transferMode= extras.getBoolean("transfermode",false);
        
        _maxSubOrder = MakeRadioButtons();
        
        
        if (_transferMode)
        	newButon.setVisibility(View.INVISIBLE);
        
        backtButon.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				if (!_transferMode)
	            {
	                /*if (AndroidOperations.ANDROSqlTableConnection != null)
	                {
	                    AndroidOperations.ANDROSqlTableTransaction.Dispose();
	                    AndroidOperations.ANDROSqlTableTransaction = null;
	                    AndroidOperations.ANDROSqlTableConnection.Dispose();
	                    AndroidOperations.ANDROSqlTableConnection = null;
	                }*/

	                AndroidOperations.CurrentTableSubOrder = -1;
	            }
				
				setResult(RESULT_CANCELED);
				finish();
			}
		});
        
        newButon.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				// TODO Auto-generated method stub
				
				if (_pressed)
					return;
				
				_pressed = true;
				
				PDialog.show();
				
				Thread thread=new Thread( new Runnable() { 
				    public void run() { 
				 
				    	MakeNewSubOrder();
				    	
				    	_handler.handleMessage(null); 
				    } 
				});
				
				thread.start();
				
			}
		});

        selectButon.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				if (_pressed)
					return;
				
				_pressed = true;
				
				PDialog.show();
				
				Thread thread=new Thread( new Runnable() { 
				    public void run() { 
				 
				    	SelectSubOrder();
				    	
				    	_handler.handleMessage(null); 
				    } 
				});
				
				thread.start();
			}
		});
    }
    
    @SuppressWarnings("finally")
	private int MakeRadioButtons()
    {
    	int i=0;
    	
    	//Call Wcs to obtain suborders
        RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID); 
		
		 try     
		 {
			 String response = clientRest.webGet("SelectSubOrderSale/", params); 
			 Type collectionType = new TypeToken<List<TableSubOrder>>(){}.getType();   
			 List<TableSubOrder> subOrders = new Gson().fromJson(response, collectionType);
			 
			 Iterator<TableSubOrder> iter = subOrders.iterator();
			 
			 RadioGroup rg = (RadioGroup)findViewById(R.id.SubOrdRadGrp);
			 
			 rg.setHorizontalGravity(Gravity.CENTER_HORIZONTAL);
			 
			 boolean first = true;
			 while (iter.hasNext())
			 {
				 TableSubOrder a = (TableSubOrder) iter.next();
				 
				 if (!a.SerialIdOk)
				 {
						setResult(RESULT_FIRST_USER);
						finish();
				 }
				 try
				 {
	            	RadioButton rb = new RadioButton(this);
	            	rb.setText(a.Description);
		                    
	            	String value = a.SubOrderNumber + "|" + a.Tariff;

	            	rb.setTag(value);

	            	rg.addView(rb);
	            	
	            	if (first)
	            	{
	            		rb.setChecked(true);
	            		first = false;
	            	}
		             
	            	i++;
				 }
				 catch (Exception ex)
				 {
					 AndroidOperations and = new AndroidOperations(this);

					 and.ShowMessage("ERROR", ex.getMessage());
				 }
				 
			 }
		 }
		 catch(Exception ex)
		 {
			 AndroidOperations.AppendLog("RSO_MakeRadioButons:" + ex.getMessage());
			 
				setResult(RESULT_FIRST_USER);
				finish();
		 }
		 finally
		 {
			 return i;
		 }
    	
    }
    
    private void MakeNewSubOrder()
    {
    	  Bundle bundle = new Bundle();
          bundle.putInt("newsuborder", 1);
          bundle.putInt("nextsuborder", _maxSubOrder);
          Intent i = new Intent();
          i.putExtras(bundle);

          setResult(RESULT_OK, i);

          finish();
    }

    private void SelectSubOrder()
    {
    	final RadioGroup rg = (RadioGroup) findViewById(R.id.SubOrdRadGrp);

        RadioButton rb = (RadioButton)findViewById(rg.getCheckedRadioButtonId());

        String value = rb.getTag().toString();

        String[] data = value.split("\\|");

        int subor = Integer.parseInt(data[0]);
        int tar = Integer.parseInt(data[1]);

        //andop.ShowMessage("ERROR", subor.ToString() + "-" + tar.ToString());
        Bundle bundle = new Bundle();
        
            bundle.putInt("resultSubOrder", subor);
            bundle.putInt("resultTariff", tar);
            bundle.putInt("newsuborder", 0);

            Intent i = new Intent();
            
            i.putExtras(bundle);
            setResult(RESULT_OK, i);
            finish();
    }
}
