package dst.net.droid;

import java.util.ArrayList;
import java.util.List;

import dst.net.jsonObj.GenericResult;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.GridView;
import android.widget.AdapterView.OnItemClickListener;

public class SelectEmployeeListAct extends Activity {
	
	private AndroidOperations _andOP;
	private boolean _pressed;
	private  ProgressDialog PDialog;
	private EmployeeImageAdapter _employeeAdapter;
	private List<GenericResult> _lstEmployees;
    private CountDownTimer _timerPressed;
	 
	 
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        setContentView(R.layout.selectemployeelist);
        
        final Button backButton = (Button)findViewById(R.id.buttonBackEmployeeList);
        final Button employeeButton = (Button) findViewById(R.id.buttonAcceptEmployeeList);
        final GridView lstEmployee = (GridView) findViewById(R.id.employeeGrid);

        _andOP= new AndroidOperations(SelectEmployeeListAct.this);
        
        _pressed = false;
        
        PDialog = new ProgressDialog(SelectEmployeeListAct.this);
        PDialog.setMessage(getText(R.string.Processing)); 
		PDialog.setIndeterminate(true); 
		PDialog.setCancelable(false);
        PDialog.setIcon(R.drawable.ic_dialog_icon);
        
		_timerPressed = new CountDownTimer(2000, 500) {
			
			@Override
			public void onTick(long millisUntilFinished) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void onFinish() {
				_pressed= false;
				
			}
		};
        
		LoadEmployees();

		lstEmployee.setAdapter(_employeeAdapter);
		lstEmployee.buildDrawingCache();
		
		lstEmployee.setOnItemClickListener(new OnItemClickListener() {

			public void onItemClick(AdapterView<?> arg0, View view, int position,
					long id) {
				// TODO Auto-generated method stub
				_employeeAdapter.setSelectedPosition(position);
			}
		});
		
        if (backButton != null)
        {
        backButton.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				_timerPressed.cancel();
				
				onBackPressed();
			}
		});
        
        }
        
        if (employeeButton != null)
        {
        	employeeButton.setOnClickListener(new OnClickListener() {
			
        		public void onClick(View v) {
				
        			if (_pressed)
        				return;
        			
        			_pressed = true;
        			
        			_timerPressed.start();
        			
        			PDialog.show();
        			
        			Thread thread=new Thread( ) { 
    				    public void run() { 
		        			
    				    	final int employee = _employeeAdapter.gettSelectedID();
		        			
    				    	if (employee<1)
    				    	{
    				    		_andOP.ShowMessage(getString(R.string.SelectEmployee), "selectEployee");
    				    		_timerPressed.cancel();
    				    	}
    				    	else if (CheckValidEmployee(employee))
		        			{
    				    		_timerPressed.cancel();
    				    		PDialog.dismiss();
    				    		
		        				//Show Table Form
		        				Intent i = new Intent(SelectEmployeeListAct.this, SelectTableNumberAct.class);
		        				startActivityForResult(i,0);
		        				
		        				
		        			}
    				    }
    				    };
    					
    					thread.start();
        		}	
        	});
        }
        
        Bundle extras = getIntent().getExtras();
		boolean _autoLogin = extras.getBoolean("autologin",false);
		
        if (_autoLogin)
        {
        	_autoLogin = false;
        	
        	if (CheckValidEmployee(AndroidOperations.CurrentEmployee))
			{
				//Show Table Form
				Intent i = new Intent(SelectEmployeeListAct.this, SelectTableNumberAct.class);
				startActivityForResult(i,0);
			}
        }
    }
    
    private void LoadEmployees()
    {
    	WcfOperations wcf= new WcfOperations();
    	
    	try
    	{
    		_lstEmployees = wcf.GetEmployeeList();
    	
	    	ArrayList<GenericResult> emp = new ArrayList<GenericResult>();
	    	
	    	for (int i=0; i< _lstEmployees.size(); i++)
	    	{
	    		emp.add(_lstEmployees.get(i));
	    	}
	    	
	    	_employeeAdapter = new EmployeeImageAdapter(emp, SelectEmployeeListAct.this);
    	}
    	catch(Exception ex)
    	{
    		AndroidOperations.AppendLog("SEL_LoadEmployees:" + ex.getMessage());
    		
    		PDialog.dismiss();

			setResult(RESULT_FIRST_USER);
			finish();
    	}
    }

	private boolean CheckValidEmployee(int employee) {
		// TODO Auto-generated method stub
		
			WcfOperations wcf = new WcfOperations();
			
			try
			{
				GenericResult resp = wcf.SelectEmployeeFromList(employee);
				
				if (!resp.SerialIdOk)
				{
					setResult(RESULT_FIRST_USER);
					finish();
					return false;
				}

				AndroidOperations.CurrentEmployee = resp.Result;
				AndroidOperations.CurrentEmployeeName = resp.Description;
				 
				if(resp.Result >0)
					return true;
				else
				{
					 _andOP.ShowMessage(getString(R.string.SelectEmployee), resp.Description);
					 return false;
				}
			}
			catch(Exception ex)
			{
				AndroidOperations.AppendLog("SE_CheckValidEmployee:" + ex.getMessage());
				
				setResult(RESULT_FIRST_USER);
				finish();
				
				return false;
			}
			finally
			{
				
			}
	}
	
	public void onActivityResult(int requestCode, int resultCode, Intent intent) 
	{ 
		PDialog.dismiss();

		_pressed= false;
		
		if (resultCode== RESULT_FIRST_USER)
    	{
			AndroidOperations.AppendLog("BackToMain FROM:" + this.toString());
    		setResult(RESULT_FIRST_USER);
    		finish();
    	}
    }
}
