package dst.net.droid;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

public class SelectPaymentAct extends Activity {
	
	private  ProgressDialog PDialog;
	private Handler _handler;
	private boolean _pressed; 
	private CountDownTimer _timerPressed;
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        setContentView(R.layout.selectpayment);
        
        final Button btnBack = (Button) findViewById(R.id.spaybtnBack);
        final Button btnPay = (Button) findViewById(R.id.spaybtnAccept);
        final Button btnPack = (Button) findViewById(R.id.spaybtnPackingSlip);
        final Button btnPack2 = (Button) findViewById(R.id.spaybtnPackingSlip2);
        
        _pressed = false;
        PDialog = new ProgressDialog(SelectPaymentAct.this);
        PDialog.setMessage(getText(R.string.Processing)); 
		PDialog.setIndeterminate(true); 
		PDialog.setCancelable(false);
		
		_timerPressed = new CountDownTimer(2000, 500) {
			
			@Override
			public void onTick(long millisUntilFinished) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void onFinish() {
				_pressed= false;
				
			}
		};
		
		_handler=new Handler(){ 
			   @Override

	                public void handleMessage(Message msg) {

				   PDialog.dismiss();
				   _pressed= false;
				}
			};
		
		
        btnBack.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
			setResult(RESULT_CANCELED);
			finish();
				
			}
		});
        
        btnPay.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {

				if (_pressed)
					return;
				else
				{
				_pressed = true;
				
				_timerPressed.start();
				
				MakePay();
				}

			}
		});
        
        btnPack.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				MakePackingSlip(1);
			}
		});
        
        btnPack2.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				MakePackingSlip(2);
			}
		});
        
        if (Parameters.DontAllowPays)
        {
        	btnPay.setEnabled(false);
        }
	}
	
	private void MakePay()
	{
		
		AndroidOperations _andOP = new AndroidOperations(SelectPaymentAct.this);
		
		PDialog.show(); 
		
		_andOP.MakeActionPaymentStep1(this, _handler);
	}
	
	private void MakePackingSlip(final int printer)
	{
		if (_pressed)
			return;
		
		_pressed = true;
		
		_timerPressed.start();
		
		PDialog.show(); 
		
		Thread thread=new Thread( new Runnable() { 
		
			public void run() { 
		 
				WcfOperations wcf = new WcfOperations();
		        
				try
				{
					if (!wcf.MakePackingSlip(printer))
					{
						AndroidOperations.AppendLog("Restarting from SelectPay_MakePaymentSlip");
						
						setResult(RESULT_FIRST_USER);
						finish();
					}
					else
					{	
						setResult(RESULT_OK);
						finish();
					}
					
				}
				catch (Exception e) {
					
					AndroidOperations.AppendLog("SelectPay_MakePaymentSlip:" + e.getMessage());
					
					setResult(RESULT_FIRST_USER);
					finish();
				}
		    	
		            //do your parsing;  //But do not update user interface here 
				_handler.handleMessage(null); 
		    } 
		});
		
		thread.start();
	}
	
	public void onActivityResult(int requestCode, int resultCode, Intent intent) 
	{ 
		PDialog.dismiss();
		
		if (resultCode== RESULT_FIRST_USER)
    	{
			AndroidOperations.AppendLog("BackToMain FROM:" + this.toString());
			
    		setResult(RESULT_FIRST_USER);
    		finish();
    		return;
    	}
		
		if (requestCode == 1) 	//Make Payment must be equal request code in ShowRegisterForm
        { 
        	if(resultCode == RESULT_OK)
        	{
        		setResult(RESULT_OK);
        		finish();
        	}
        }
		else if (requestCode == 5) 	//Make Payment must be equal request code in ShowRegisterForm
        { 
        	if(resultCode == RESULT_OK)
        	{
        		setResult(RESULT_OK);
        		finish();
        	}
        }
	
    }

}
