package dst.net.droid;

import android.app.Activity;
import android.app.ProgressDialog;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

public class ShowSelectTicketAct extends Activity {
	
	private boolean _directPayment;
	private double  _change;
	private  ProgressDialog PDialog;
	private boolean _pressed;
	private CountDownTimer _timerPressed;

	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
	
        Bundle extras = getIntent().getExtras();
        _directPayment= extras.getBoolean("directPayment",true);

        _change = 0;
        _pressed = false;
        
        PDialog = new ProgressDialog(ShowSelectTicketAct.this);
        PDialog.setMessage(getText(R.string.Processing)); 
        PDialog.setCancelable(false);
		PDialog.setIndeterminate(true); 
		
		_timerPressed = new CountDownTimer(2000, 500) {
			
			@Override
			public void onTick(long millisUntilFinished) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void onFinish() {
				_pressed= false;
				
			}
		};

		
        setContentView(R.layout.showselectticket);
        
        final Button btnTicket = (Button) findViewById(R.id.sptbtnTicket);
        final Button btnTicket2 = (Button) findViewById(R.id.sptbtnTicket2);
        final Button btnNoTicket = (Button) findViewById(R.id.sptbnNoTicket);
        final Button btnBack = (Button) findViewById(R.id.sptbnBack);
        final Button btnPackingSlip = (Button) findViewById(R.id.sptbtnPackingSlip);
        final Button btnPackingSlip2 = (Button) findViewById(R.id.sptbtnPackingSlip2);
        
        
        if (!_directPayment)
        {
        	btnPackingSlip.setVisibility(View.INVISIBLE);
        	btnPackingSlip2.setVisibility(View.INVISIBLE);
        	_change =extras.getDouble("change",0);
        }
        
        btnBack.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				// TODO Auto-generated method stub
				setResult(RESULT_CANCELED);
				finish();
			}
		});
        
        btnPackingSlip.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				if (_pressed)
					return;
				
				_pressed = true;
				
				_timerPressed.start();
				
				PDialog.show(); 
				
				Thread thread=new Thread() { 
				    public void run() { 
				    	
				    	WcfOperations wcf = new WcfOperations();
						
						if (wcf.MakePackingSlip(1))
						{
							PDialog.dismiss(); 
							setResult(RESULT_OK);
							finish();
						}
						else
						{
							PDialog.dismiss(); 
							setResult(RESULT_FIRST_USER);
							finish();
						}
				    } 
				};
				
				thread.start();

			}
		});
        
        btnPackingSlip2.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				if (_pressed)
					return;
				
				_pressed = true;
				
				_timerPressed.start();
				
				PDialog.show(); 
				
				Thread thread=new Thread() { 
				    public void run() { 
				    	
				    	WcfOperations wcf = new WcfOperations();
						
						if (wcf.MakePackingSlip(2))
						{
							PDialog.dismiss(); 
							setResult(RESULT_OK);
							finish();
						}
						else
						{
							PDialog.dismiss(); 
							setResult(RESULT_FIRST_USER);
							finish();
						}
				    } 
				};
				
				thread.start();

			}
		});
	
        
        
        btnTicket.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				if (_pressed)
					return;
				
				_pressed = true;
				
				_timerPressed.start();
				
				PDialog.show();
				
				Thread thread=new Thread() { 
				    public void run() { 
				
				    	WcfOperations wcf = new WcfOperations();
						
						try
						{
							PDialog.dismiss();
							wcf.ProcessPayment(1, _directPayment, _change);
							setResult(RESULT_OK);
							finish();
						}
						catch (Exception e) 
						{
							AndroidOperations.AppendLog("ShowSelectTicket_Ticket:" + e.getMessage());
							
							PDialog.dismiss();
							setResult(RESULT_FIRST_USER);
							finish();
						}
				    } 
				};
				
				thread.start();
			}
		});
        
        btnTicket2.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {

				if (_pressed)
					return;
				
				_pressed = true;
				
				_timerPressed.start();
				
				PDialog.show();
				
				Thread thread=new Thread( ) { 
				    public void run() { 
				 
				    	WcfOperations wcf = new WcfOperations();
						
				    	try
				    	{
				    		wcf.ProcessPayment(2, _directPayment, _change);
				    		PDialog.dismiss();
							setResult(RESULT_OK);
							finish();
						}
						catch (Exception e) 
						{
							AndroidOperations.AppendLog("ShowSelectTicket_Ticket2:" + e.getMessage());
							
							PDialog.dismiss();
						
							setResult(RESULT_FIRST_USER);
							finish();
						}
							
						
						
				    
				    } 
				};
				
				thread.start();
			}
		});
        
        btnNoTicket.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				if (_pressed)
					return;
				
				_pressed = true;
				
				_timerPressed.start();
				
				PDialog.show();
				
				Thread thread=new Thread() { 
				    public void run() { 
				
				    	WcfOperations wcf = new WcfOperations();
						
						try
						{
							wcf.ProcessPayment(0, _directPayment, _change);
							PDialog.dismiss();
							setResult(RESULT_OK);
							finish();
						}
						catch (Exception e)
						{
							AndroidOperations.AppendLog("ShowSelectTicket_TicketNO:" + e.getMessage());
							
							PDialog.dismiss();
							setResult(RESULT_FIRST_USER);
							finish();
						}
				    } 
				};
				
				thread.start();
			}
		});
	
        if (Parameters.DontAllowPays)
        {
        	btnTicket.setEnabled(false);
        	btnNoTicket.setEnabled(false);
        	btnTicket2.setEnabled(false);
        }
        	
	
	}
}
