package dst.net.droid;

import java.util.ArrayList;

import dst.net.jsonObj.GenericResultInt;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.util.TypedValue;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.animation.Animation;
import android.view.animation.Animation.AnimationListener;
import android.view.animation.AnimationUtils;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;

public class TableListAdapter extends ArrayAdapter<GenericResultInt> {
	 
    private ArrayList<GenericResultInt> items;
    private Context _context;
    private int _selectedPos = -1;
    private AndroidOperations _andOP;
    
    public TableListAdapter(Context context,  ArrayList<GenericResultInt> items) {
             super(context, 0, items);
             this.items = items;
             _context = context;
             _andOP = new AndroidOperations(context);
     }

    
    public int getPosition()
    {
    	return _selectedPos;
    }
    
    public int gettSelectedID(){
    	
    	if (_selectedPos>-1)
    	{
    		return items.get(_selectedPos).Result;
    		
    	}
    	else
    		return -1;
	}
    
    
    public void setSelectedPosition(int pos){
    	_selectedPos = pos;
		// inform the view of this change
		notifyDataSetChanged();
	}

    @Override
     public View getView(final int position, View convertView, ViewGroup parent) {
             
    		Button v;
             
    		int width = _andOP.GetRealPixel(60);
    		int height = _andOP.GetRealPixel(60);
    		
             if (convertView == null) {
            	 v = new Button(_context);
            	 v.setTextSize(TypedValue.COMPLEX_UNIT_SP, 18);
            	 v.setPadding(5, 5, 5, 5);
             }
             else
            	 v = (Button) convertView;
             
             GenericResultInt o = items.get(position);
             
             if (o != null) 
             {
            	 v.setTag(o.Result);
                     
            	 if (v != null) 
            		 v.setText(o.Description);                            
            	 
            	 if (o.Value==0)
            	 {	 
            		 v.setTextColor(Color.WHITE);
            		 
            		Bitmap  bm = Bitmap.createScaledBitmap(BitmapFactory.decodeResource(_context.getResources(), R.drawable.tablefree),  width, height, true);
            		Drawable d =new BitmapDrawable(bm);
            		v.setBackgroundDrawable(d);
            	 }
            	 else if (o.Value==1)
            	 {
            		v.setTextColor(Color.WHITE);
            		
            		Bitmap  bm = Bitmap.createScaledBitmap(BitmapFactory.decodeResource(_context.getResources(), R.drawable.tableoc),  width, height, true);
             		Drawable d =new BitmapDrawable(bm);
             		v.setBackgroundDrawable(d);
            	 }
            	 else if (o.Value==2)
            	 {
            		 v.setTextColor(Color.BLACK);
            		 
            		Bitmap  bm = Bitmap.createScaledBitmap(BitmapFactory.decodeResource(_context.getResources(), R.drawable.tableticket),  width, height, true);
              		Drawable d =new BitmapDrawable(bm);
              		v.setBackgroundDrawable(d);
            	 }
             }
             
             v.setOnClickListener(new OnClickListener() {
				
				public void onClick(View v) {
					// TODO Auto-generated method stub
					Animation rotate = AnimationUtils.loadAnimation(_context, R.anim.scale_alpha);
					
					rotate.setAnimationListener(new AnimationListener() {
						
						public void onAnimationStart(Animation animation) {
							// TODO Auto-generated method stub
							
						}
						
						public void onAnimationRepeat(Animation animation) {
							// TODO Auto-generated method stub
							
						}
						
						public void onAnimationEnd(Animation animation) {
							
							((SelectTableNumberAct) _context).GoToTableFloor(gettSelectedID());
						}
					});
					
					_selectedPos = position;
					v.startAnimation(rotate);
				}
			});
             
             
             return v;
     }
}