package dst.net.droid;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import android.util.Log;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import dst.net.droid.MainActivity.LoadViewTask;
import dst.net.jsonObj.Article;
import dst.net.jsonObj.ArticleShortCut;
import dst.net.jsonObj.EmployeeImage;
import dst.net.jsonObj.FreezeSalesOrderLine;
import dst.net.jsonObj.FreezeSalesOrderLineOption;
import dst.net.jsonObj.GenericResult;
import dst.net.jsonObj.GenericResultDouble;
import dst.net.jsonObj.GenericResultInt;
import dst.net.jsonObj.ItemDataModifier;
import dst.net.jsonObj.ItemDataNode;
import dst.net.jsonObj.PaymentMethodLine;
import dst.net.jsonObj.PreOrderInfo;
import dst.net.rest.RestClient;
import dst.net.wcf.Base64;

	public class WcfOperations {

	public WcfOperations()
	{

	}
	
	public boolean IsLite()
	{
		
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
    	Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		

		String response = clientRest.webGet("IsLite/", params); 
		boolean resp = new Gson().fromJson(response, boolean.class);
			
		return resp;
	}
	
	public double GetOrderTotal()
    {
    	RestClient clientRest = new RestClient(Parameters.WcfUrl);
    	Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		

		String response = clientRest.webGet("GetOrderTotal/", params); 
		GenericResultDouble resp = new Gson().fromJson(response, GenericResultDouble.class);
			
		return resp.Value;
    }
	
	public boolean CheckToLoadImages(int timeOut)
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl,timeOut);
    	Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);

		String response = clientRest.webGet("CheckToLoadImages/", params); 
		boolean resp = new Gson().fromJson(response, boolean.class);
			
		return resp;
	}
	
	public boolean CheckPassword(int timeOut)
    {
    	RestClient clientRest = new RestClient(Parameters.WcfUrl,timeOut);
    	Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("message", Parameters.Password);

		String response = clientRest.webGet("CheckPassword/", params); 
		boolean resp = new Gson().fromJson(response, boolean.class);
			
		return resp;
    }

	public GenericResult SelectEmployee(int number)
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("number",String.valueOf(number));  
		
		 try     
		 {
			 String response = clientRest.webGet("SelectEmployee/", params); 
			 
			 if (response ==null || response =="")
			 {
				 AndroidOperations.AppendLog("Restarting from SelectEmployee");
				 GenericResult resp = new GenericResult();
				 resp.SerialIdOk = false;
				 resp.Result= -100;
				 
				 return resp;
			 }
			 else
			 {
				 GenericResult resp = new Gson().fromJson(response, GenericResult.class);
				 return resp;
			 }
		 }
		 catch (Exception ex)
		 {
			 AndroidOperations.AppendLog("SelectEmployee:" + ex.getMessage());
			 GenericResult resp = new GenericResult();
			 resp.SerialIdOk = false;
			 return resp;
		 }
	}
	
	public GenericResult SelectEmployeeFromList(int number)
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("number",String.valueOf(number));  
		
		 try     
		 {
			 String response = clientRest.webGet("SelectEmployeeFromList/", params); 
			 GenericResult resp = new Gson().fromJson(response, GenericResult.class);
			 return resp;
		 }
		 catch (Exception ex)
		 {
			 AndroidOperations.AppendLog("SelectEmployeeFromList:" + ex.getMessage());
			 GenericResult resp = new GenericResult();
			 resp.SerialIdOk = false;
			 return resp;
		 }
	}
	
	public boolean ProcessPayment(int printTicket, boolean directPay, double change)
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl,Parameters.WcfTimeOut+25000);
		Map<String, String> params = new HashMap<String, String>();
		
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("printTicket",String.valueOf(printTicket));
		params.put("directPay", String.valueOf(directPay));
		params.put("change", String.valueOf(change));
		
			String response = clientRest.webGet("ProcessPayment/", params); 
			GenericResultDouble resp = new Gson().fromJson(response, GenericResultDouble.class);
			
			if (!resp.SerialIdOk || resp.Result!=1)
				return false;
			
	    	return true;
	}
	
	public boolean MakePackingSlip(int printer)
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("printTo", String.valueOf(printer));
		

			String response = clientRest.webGet("MakePackingslip/", params); 
			
			if (response==null || response =="")
			{
				return false;
			}
			
			GenericResult resp = new Gson().fromJson(response, GenericResult.class);
			
			if (!resp.SerialIdOk)
			{
				return false;
			}
			
			return true;

	}
	
	public boolean AddOrderPay(String method , double amount)
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("method", method);
		params.put("amount", String.valueOf(amount));
		
		try     
		{   
			String response = clientRest.webGet("AddOrderPay/", params); 
			GenericResult resp = new Gson().fromJson(response, GenericResult.class);
			
	    	return resp.Result>0;
		}
		catch (Exception e) {
			
			AndroidOperations.AppendLog("AddOrderPay:" + e.getMessage());
			return false;
			// TODO: handle exception
		}
	}
	
	public boolean FreeTableLock()
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		
		params.put("deviceid", AndroidOperations.DeviceID);
		
		try
		{
			String response = clientRest.webGet("FreeTableLock/", params); 
			GenericResult resp = new Gson().fromJson(response, GenericResult.class);
			
			if (!resp.SerialIdOk)
				return false;
			else
				return true;
		}
		catch (Exception e) {
			return false;		
		}
	}
	
	public int wcf_MakeSend(boolean newSubOrder)
    {
		try
		{
    	RestClient clientRest = new RestClient(Parameters.WcfUrl,Parameters.WcfTimeOut+25000);
		Map<String, String> params = new HashMap<String, String>();
		
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("createSubOrder", String.valueOf(newSubOrder));
 
		String response = clientRest.webGet("MakeSend/", params); 
		GenericResultInt resp = new Gson().fromJson(response, GenericResultInt.class);
			
		if (!resp.SerialIdOk)
			return -1;
		else if (newSubOrder)
			return resp.Value;
		else
			return 0;
		}
		catch(Exception ex)
		{
			return -1;
		}

    }
	
	public boolean ClearPays()
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		
		params.put("deviceid", AndroidOperations.DeviceID);
	
 
			String response = clientRest.webGet("ClearPays/", params); 
			GenericResult resp = new Gson().fromJson(response, GenericResult.class);
			
	    	return resp.Result>0;

	}

	public List<PaymentMethodLine> GetPaymentMethods()
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();

		params.put("deviceid", AndroidOperations.DeviceID);
  
			String response = clientRest.webGet("GetPaymentMethods/", params);
			
			Type collectionType = new TypeToken<List<PaymentMethodLine>>(){}.getType();
			List<PaymentMethodLine> resp = new Gson().fromJson(response, collectionType);
			
			return  resp;
	}

	public List<ItemDataNode> GetArticleFolder(int folder)
	{

			 RestClient clientRest = new RestClient(Parameters.WcfUrl);
			 Map<String, String> params = new HashMap<String, String>();
				
			 params.put("deviceid", AndroidOperations.DeviceID);
			 params.put("folder", String.valueOf(folder));  
			 
			 String response = clientRest.webGet("GetArticleFolder/", params); 

			 Type collectionType = new TypeToken<List<ItemDataNode>>(){}.getType();
			 
			 List<ItemDataNode> resp = new Gson().fromJson(response, collectionType);
			 
			 return resp;
	}
	
	public List<GenericResult> GetEmployeeList()
	{
   
			 RestClient clientRest = new RestClient(Parameters.WcfUrl);
			 Map<String, String> params = new HashMap<String, String>();
				
			 params.put("deviceid", AndroidOperations.DeviceID);
			 
			 String response = clientRest.webGet("GetEmployeeList/", params); 

			 Type collectionType = new TypeToken<List<GenericResult>>(){}.getType();
			 
			 List<GenericResult> resp = new Gson().fromJson(response, collectionType);
			 
			 return resp;
	}
	
	public List<GenericResult> GetFloorList()
	{

			 RestClient clientRest = new RestClient(Parameters.WcfUrl);
			 Map<String, String> params = new HashMap<String, String>();
				
			 params.put("deviceid", AndroidOperations.DeviceID);
			 
			 String response = clientRest.webGet("GetFloorList/", params); 

			 Type collectionType = new TypeToken<List<GenericResult>>(){}.getType();
			 
			 List<GenericResult> resp = new Gson().fromJson(response, collectionType);
			 
			 return resp;
	}
	
	public List<GenericResultInt> GetTableList(int floor)
	{
 
			 RestClient clientRest = new RestClient(Parameters.WcfUrl);
			 Map<String, String> params = new HashMap<String, String>();
				
			 params.put("deviceid", AndroidOperations.DeviceID);
			 params.put("floor", String.valueOf(floor));

			 try
			 {
			 String response = clientRest.webGet("GetTableList/", params); 
			 
			 Type collectionType = new TypeToken<List<GenericResultInt>>(){}.getType();
			 
			 List<GenericResultInt> resp = new Gson().fromJson(response, collectionType);
			 
			 return resp;
			 
			 }
			 catch (Exception e) {
				return null;
			}
	}
	
	public List<GenericResultInt> GetPrinters()
	{
 
			 RestClient clientRest = new RestClient(Parameters.WcfUrl);
			 Map<String, String> params = new HashMap<String, String>();
				
			 params.put("deviceid", AndroidOperations.DeviceID);
			
			 
			 String response = clientRest.webGet("GetPrinters/", params); 

			 Type collectionType = new TypeToken<List<GenericResultInt>>(){}.getType();
			 
			 List<GenericResultInt> resp = new Gson().fromJson(response, collectionType);
			 
			 return resp;
	}
	
	public List<String> GetPredefinedList()
	{
 
			 RestClient clientRest = new RestClient(Parameters.WcfUrl);
			 Map<String, String> params = new HashMap<String, String>();
				
			 params.put("deviceid", AndroidOperations.DeviceID);
			
			 
			 String response = clientRest.webGet("GetKitchenPredefined/", params); 

			 Type collectionType = new TypeToken<List<String>>(){}.getType();
			 
			 List<String> resp = new Gson().fromJson(response, collectionType);
			 
			 return resp;
	}

	public List<ItemDataNode> GetArticleOptions(int article, int idLine, int piece, boolean fromMenu)
	{
   	 	try     
		{   
			 RestClient clientRest = new RestClient(Parameters.WcfUrl);
			 Map<String, String> params = new HashMap<String, String>();
				
			 params.put("deviceid", AndroidOperations.DeviceID);
			 params.put("article", String.valueOf(article));
			 params.put("idLine", String.valueOf(idLine));
			 params.put("piece", String.valueOf(piece));  
			 params.put("frommenu", String.valueOf(fromMenu));
			 
			 String response = clientRest.webGet("GetArticleOptions/", params); 

			 Type collectionType = new TypeToken<List<ItemDataNode>>(){}.getType();
			 
			 List<ItemDataNode> resp = new Gson().fromJson(response, collectionType);
			 
			 return resp;
		 }
		 catch(Exception ex)
		 {
			 AndroidOperations.AppendLog("GetArticleOptions:" + ex.getMessage());
			 return null;
		 }
		
	}
	
	public List<ItemDataNode> GetArticlePieces(int article, int idLine)
	{
   	 	try     
		{   
			 RestClient clientRest = new RestClient(Parameters.WcfUrl);
			 Map<String, String> params = new HashMap<String, String>();
				
			 params.put("deviceid", AndroidOperations.DeviceID);
			 params.put("article", String.valueOf(article));
			 params.put("idLine", String.valueOf(idLine));  
			 
			 String response = clientRest.webGet("GetArticlePieces/", params); 

			 Type collectionType = new TypeToken<List<ItemDataNode>>(){}.getType();
			 
			 List<ItemDataNode> resp = new Gson().fromJson(response, collectionType);
			 
			 return resp;
		 }
		 catch(Exception ex)
		 {
			 AndroidOperations.AppendLog("GetArticlePieces:" + ex.getMessage());
			 return null;
		 }
		
	}
	
	public List<ItemDataModifier> GetModifiers(int article, int lineID, boolean fromMenu)
	{
 
			 RestClient clientRest = new RestClient(Parameters.WcfUrl);
			 Map<String, String> params = new HashMap<String, String>();
				
			 params.put("deviceid", AndroidOperations.DeviceID);
			 params.put("article", String.valueOf(article));
			 params.put("lineID", String.valueOf(lineID));
			 params.put("frommenu", String.valueOf(fromMenu));
			 
			 String response = clientRest.webGet("GetArticleModifiers/", params); 

			 Type collectionType = new TypeToken<List<ItemDataModifier>>(){}.getType();
			 
			 List<ItemDataModifier> resp = new Gson().fromJson(response, collectionType);
			 
			 return resp;
	}
	
	public boolean IsDefaultArticle( int article)
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("article",String.valueOf(article));
	
		String response = clientRest.webGet("IsDefaultArticle/", params); 
		GenericResult resp = new Gson().fromJson(response, GenericResult.class);
			
		return resp.Result==1;

	}

	public  void  GetShortCuts(int timeOut)
	{
		 RestClient clientRest = new RestClient(Parameters.WcfUrl,timeOut);
		 Map<String, String> params = new HashMap<String, String>();
			
		 params.put("deviceid", AndroidOperations.DeviceID);
		 
		 String response = clientRest.webGet("GetShortCuts/", params); 

		 Type collectionType = new TypeToken<List<ArticleShortCut>>(){}.getType();
		 
		 Parameters.ShortCutsList = new Gson().fromJson(response, collectionType);
	}
	
	public void GetEmployeeImages(int timeOut)
	{
		 RestClient clientRest = new RestClient(Parameters.WcfUrl,timeOut);
		 Map<String, String> params = new HashMap<String, String>();
			
		 params.put("deviceid", AndroidOperations.DeviceID);
		 
		 String response = clientRest.webGet("GetEmployees/", params); 

		 Type collectionType = new TypeToken<List<EmployeeImage>>(){}.getType();
		 
		 Employee.EmployeeImage = new Gson().fromJson(response, collectionType);
		 Employee.EmployeeImageMap = new HashMap<Integer, EmployeeImage>();
		 
		 	 
		 for(int i=0; i< Employee.EmployeeImage.size(); i++)
		 {
			 try
			 {
				 EmployeeImage  a =Employee.EmployeeImage.get(i);
				 
				 a.ImageBytes = Base64.decode(a.Image);
				 
				 Employee.EmployeeImageMap.put(a.Number,a);

			 }
	         catch (Exception ex)
	         {
	        	 ex.printStackTrace();
	         }
		 }  
		 Employee.EmployeeImage.clear();
	 }
		 
    public  void ReadArticlesImages(LoadViewTask task, int counter, boolean clearCache, int timeOut)
    {
    	 try     
		 {   
			 if (clearCache)
			 {
				 String dirPath = Parameters.FileImagePath;
				 
				 File dir = new File(dirPath);
				 
				 if (dir.isDirectory()) { 
				        String[] children = dir.list(); 
				        for (int j = 0; j < children.length; j++) { 
				            new File(dir, children[j]).delete(); 
				        } 
				    } 
				 
				 dirPath = Parameters.FileImagePathRender;
				 dir = new File(dirPath);
				 
				 if (dir.isDirectory()) { 
				        String[] children = dir.list(); 
				        for (int j = 0; j < children.length; j++) { 
				            new File(dir, children[j]).delete(); 
				        } 
				    } 
			 }
    		 
    		//Here count = 20 //we can do 40 steps
			 RestClient clientRest = new RestClient(Parameters.WcfUrl,timeOut);
			 Map<String, String> params = new HashMap<String, String>();
				
			 params.put("deviceid", AndroidOperations.DeviceID);  
			 
			 String response = clientRest.webGet("GetArticleImagesList/", params); 

			 Type collectionType = new TypeToken<List<Integer>>(){}.getType();
			 
			 List<Integer> articleList = new Gson().fromJson(response, collectionType);
			 
			 Item.ArticleImageMap = new HashMap<Integer, String>();
			 
			 double step = 0;
			 double stepValue = 0;
			 
			 if (articleList.size()>0)
				 stepValue = (double)40 /(double) articleList.size();
			 
			 for (int i = 0; i< articleList.size(); i++)
			 {
				 System.gc();
				 
				 step+= stepValue;
				 params.clear();
				 
				 params.put("deviceid", AndroidOperations.DeviceID);  
				 params.put("article", String.valueOf(articleList.get(i)));
				 
				 String responseImage = clientRest.webGet("GetArticleImage/", params);
				 BufferedOutputStream out = null;
				 
				 try
				 {
					 Article a = new Gson().fromJson(responseImage, Article.class);
					 String path = Parameters.FileImagePath+a.Number+ ".jpg";
					 Item.ArticleImageMap.put(a.Number,path);
					 
					 byte[] image = Base64.decode(a.Image);
			 
			         File file = new File(path);
			         file.createNewFile();
			         
		        	 out = new BufferedOutputStream(new FileOutputStream(file)); 
		        	 out.write(image, 0, image.length);
				 }
		         catch (Exception ex)
		         {
		        	 AndroidOperations.AppendLog("ReadArticlesImages1:" + ex.getMessage());
		        	 ex.printStackTrace();
		         }
	        	 finally 
		         {   
		        	 if (out != null)
		        	 {    
		        		 out.close();  
		        	 }  
		         }

				 if (task!=null)
					{
						task.Update(counter+(int)step);
					}
				 
			 }
		 }
		 catch(Exception ex)
		 {
			 AndroidOperations.AppendLog("ReadArticlesImages2:" + ex.getMessage());
			 
			 ex.printStackTrace();
		 }
    }

    public GenericResult AddFreezeLine(int articleNumber, double quantity, double price,ArrayList<Integer> modifiers,ArrayList<FreezeSalesOrderLineOption> options, int piece, int forceDinnerMode, String freeText, boolean fromPromotion, boolean fromMenu, int weight)
    {
    	
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
			
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("article", String.valueOf(articleNumber));
		params.put("quantity", String.valueOf(quantity));
	    params.put("price", String.valueOf(price));
		params.put("piece", String.valueOf(piece));
		params.put("forcedinnermode", String.valueOf(forceDinnerMode));
		params.put("freetext",freeText);
		params.put("fromPromotion",String.valueOf(fromPromotion));
		params.put("fromMenu",String.valueOf(fromMenu));
		params.put("weight",String.valueOf(weight));
		
		String paramMod = "";
		for (int i=0; i< modifiers.size(); i++)
		{
			paramMod+= modifiers.get(i) + ",";
		}
		if (paramMod.length()>0)
			paramMod = paramMod.substring(0,paramMod.length()-1);
		
		params.put("modifiers", paramMod);
		
		String paramOpt = "";
		
		if (options!=null)
		{
			for (int i=0; i< options.size(); i++)
			{
				paramOpt+= options.get(i).Article + ",";
			}
			
			if (paramOpt.length()>0)
				paramOpt = paramOpt.substring(0,paramOpt.length()-1);
		}
		
		params.put("options", paramOpt);
		
  
		try
		{
		
		String response = clientRest.webGet("AddFreezeArticle/", params); 
		GenericResult resp = new Gson().fromJson(response, GenericResult.class);

	    return resp;
		}
		catch(Exception ex)
		{
			return null;
		}
    }

    public GenericResult UpdateModifiers(int lineID, ArrayList<Integer> modifiers, String freeText)
    {
    	Log.i("getView()", "Service_Start");
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		String paramMod = "";
		for (int i=0; i< modifiers.size(); i++)
		{
			paramMod+= modifiers.get(i) + ",";
		}
		if (paramMod.length()>0)
			paramMod = paramMod.substring(0,paramMod.length()-1);
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("lineid", String.valueOf(lineID));
		params.put("modifiers", paramMod);
		params.put("freetext", freeText);
		
		Log.i("getView()", "Service_Parameters");
		
  
			String response = clientRest.webGet("UpdateModifiers/", params); 
			GenericResult resp = new Gson().fromJson(response, GenericResult.class);

	    	return resp;
    }
    
    public GenericResult UpdateOptionals(int lineID, ArrayList<FreezeSalesOrderLineOption> options)
    {
    
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("lineid", String.valueOf(lineID));
		//params.put("options", paramMod);
		
		String response = clientRest.webGet("UpdateOptionals/", params); 
		GenericResult resp = new Gson().fromJson(response, GenericResult.class);

		return resp;
    }
    
    public boolean OptionAction(int lineID,int action, int option)
    {
    	// WEB SERVICE
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("lineid",String.valueOf(lineID));
		params.put("action", String.valueOf(action));
		params.put("option", String.valueOf(option));
		
		clientRest.webGet("OptionalAction/", params); 
				
		return true;
    }
    
    public boolean ChangeQuantity(int lineID, double newQuantity)
    {
    	// WEB SERVICE
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("lineid",String.valueOf(lineID));
		params.put("newquantity", String.valueOf(newQuantity));
	
  
		/*String response = */clientRest.webGet("DoChangeQuantity/", params); 
			
		//GenericResult resp = new Gson().fromJson(response, GenericResult.class);
			
		return true;
    }
    
    public boolean ChangeWeight(int lineID, int newWeight)
    {
    	// WEB SERVICE
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("lineid",String.valueOf(lineID));
		params.put("newweight", String.valueOf(newWeight));
	
  
		/*String response = */clientRest.webGet("DoChangeWeight/", params); 
			
		//GenericResult resp = new Gson().fromJson(response, GenericResult.class);
			
		return true;
    }
    
    public boolean changePrice(int lineID, double newPrice)
    {
    	// WEB SERVICE
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("lineid",String.valueOf(lineID));
		params.put("newprice", String.valueOf(newPrice));
		
  
		/*String response =*/ clientRest.webGet("ChangePrice/", params); 
			
		//GenericResult resp = new Gson().fromJson(response, GenericResult.class);

		return true;
    }
    
    public boolean changeSetPiece(int lineID, double newPrice,int  piece)
    {
    	// WEB SERVICE
    	RestClient clientRest = new RestClient(Parameters.WcfUrl);
    	Map<String, String> params = new HashMap<String, String>();
    			
    	params.put("deviceid", AndroidOperations.DeviceID);
    	params.put("lineid",String.valueOf(lineID));
    	params.put("newprice", String.valueOf(newPrice));
    	params.put("piece", String.valueOf(piece));
    			
    	  
    	/*String response =*/ clientRest.webGet("ChangePiece/", params); 
    				
    	//GenericResult resp = new Gson().fromJson(response, GenericResult.class);

    	return true;
    }
    public ItemDataNode GetArticleInfo(int article)
    {
    	// WEB SERVICE
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("article",String.valueOf(article));
		
		String response = clientRest.webGet("GetArticleInfo/", params); 
		ItemDataNode resp = new Gson().fromJson(response, ItemDataNode.class);
		return resp;

    }

    public int GetCurrentSession()
    {
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		
		params.put("deviceid", AndroidOperations.DeviceID);
	
 
		String response = clientRest.webGet("GetCurrentSession/", params); 
		GenericResultInt resp = new Gson().fromJson(response, GenericResultInt.class);
			
		return resp.Result;
    }

    public GenericResult PrintKitchenMessage(ArrayList<String> printers,String message)
    {
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
	
		params.put("message", message);
		
		String paramPrinters = "";
		for (int i=0; i< printers.size(); i++)
		{
			paramPrinters+= printers.get(i) + ",";
		}
		
		if (paramPrinters.length()>0)
			paramPrinters = paramPrinters.substring(0,paramPrinters.length()-1);
		
		params.put("printers", paramPrinters);
		
		try
		{
			String response = clientRest.webGet("PrintKitchenMessage/", params); 
			GenericResult resp = new Gson().fromJson(response, GenericResult.class);
			
			return resp;
		}
		catch (Exception e) {
			return null;
		}
		

		
    }
    
    public void PrintFaxMessage(ArrayList<String> printers,String message)
    {
    	RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
	
		params.put("message",  message);
		
		String paramPrinters = "";
		
		for (int i=0; i< printers.size(); i++)
		{
			paramPrinters+= printers.get(i) + ",";
		}
		
		if (paramPrinters.length()>0)
			paramPrinters = paramPrinters.substring(0,paramPrinters.length()-1);
		
		params.put("printers", paramPrinters);
		
		/*String response = */clientRest.webGet("PrintFaxMessage/", params); 
		
		//GenericResult resp = new Gson().fromJson(response, GenericResult.class);

		//return resp;
    }
    
	public void ExitApplication() {
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		
		params.put("deviceid", AndroidOperations.DeviceID);

		/*String response = */clientRest.webGet("ExitApplication/", params); 

	}
	
	public List<ItemDataNode> GetMenuArticles(int menuArticle)
	{
		 RestClient clientRest = new RestClient(Parameters.WcfUrl);
		 Map<String, String> params = new HashMap<String, String>();
			
		 params.put("deviceid", AndroidOperations.DeviceID);
		 params.put("menuarticle", String.valueOf(menuArticle));  
		 
		 String response = clientRest.webGet("GetMenuArticles/", params); 

		 Type collectionType = new TypeToken<List<ItemDataNode>>(){}.getType();
		 
		 List<ItemDataNode> resp = new Gson().fromJson(response, collectionType);
		 
		 return resp;
	}
	
	public List<ItemDataNode> GetPromoArticles(int promoArticle)
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		 Map<String, String> params = new HashMap<String, String>();
			
		 params.put("deviceid", AndroidOperations.DeviceID);
		 params.put("promoArticle", String.valueOf(promoArticle));  
		 
		 String response = clientRest.webGet("GetPromoArticles/", params); 

		 Type collectionType = new TypeToken<List<ItemDataNode>>(){}.getType();
		 
		 List<ItemDataNode> resp = new Gson().fromJson(response, collectionType);
		 
		 return resp;
	}
	
	public List<String> GetFaxPrinters()
	{
		 RestClient clientRest = new RestClient(Parameters.WcfUrl);
		 Map<String, String> params = new HashMap<String, String>();
			
		 params.put("deviceid", AndroidOperations.DeviceID);
		 
		 String response = clientRest.webGet("GetFaxPrinters/", params); 

		 Type collectionType = new TypeToken<List<String>>(){}.getType();
		 
		 List<String> resp = new Gson().fromJson(response, collectionType);
		 
		 return resp;
	}
	
	public List<Integer> GetCurrentDiners()
	{
		 RestClient clientRest = new RestClient(Parameters.WcfUrl);
		 Map<String, String> params = new HashMap<String, String>();
			
		 params.put("deviceid", AndroidOperations.DeviceID);
		 
		 String response = clientRest.webGet("GetOrderDiner/", params); 

		 Type collectionType = new TypeToken<List<Integer>>(){}.getType();
		 
		 List<Integer> resp = new Gson().fromJson(response, collectionType);
		 
		 return resp;	
	}
	
	public void SetCurrentDiner(int number, boolean cancelMode)
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
			
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("nextcourse", String.valueOf(number));
		params.put("cancelmode", String.valueOf(cancelMode));
		 
		 /*String response = */clientRest.webGet("SetCurrentDiner/", params); 
		 
	}

	/*public int StartMenuTransaction(int number) 
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
			
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("menuarticle", String.valueOf(number));
		
		String response = clientRest.webGet("StartMenuTransaction/", params); 
		
		int temp  =  new Gson().fromJson(response, int.class);
		
		return temp;
	}*/
	
	public List<FreezeSalesOrderLine> StartMenuTransaction(int number, int piece) 
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
			
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("menuarticle", String.valueOf(number));
		params.put("piece", String.valueOf(piece));
		
		String response = clientRest.webGet("StartMenuTransaction/", params); 
		
		Type collectionType = new TypeToken<List<FreezeSalesOrderLine>>(){}.getType();
		List<FreezeSalesOrderLine> resp = new Gson().fromJson(response, collectionType);
		
		return resp;
	}
	

	public GenericResult AddMenuLine(int  article,double quantity,double  price,int  piece,String modifiers, String options, String freeMod, int courseNumber)
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
			
		params.put("deviceid", AndroidOperations.DeviceID);
	
		params.put("article", String.valueOf(article));
		params.put("quantity",String.valueOf( quantity));
		params.put("price", String.valueOf(price));
		params.put("modifiers", modifiers);
		params.put("options", options);
		params.put("piece", String.valueOf(piece));
		params.put("freemod", freeMod);
		params.put("course", String.valueOf(courseNumber));
		
		String response = clientRest.webGet("AddMenuLine/", params); 
		
		GenericResult resp = new Gson().fromJson(response, GenericResult.class);

		return resp;
	}

	public void EndMenuTransaction(int number) 
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
			
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("menuarticle", String.valueOf(number));
		
		/*String response = */clientRest.webGet("EndMenuTransaction/", params); 

	}

	public List<FreezeSalesOrderLine> GetLinesInMemory() 
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();

		params.put("deviceid", AndroidOperations.DeviceID);
		
		String response = clientRest.webGet("GetLinesInMemory/", params);
		
		Type collectionType = new TypeToken<List<FreezeSalesOrderLine>>(){}.getType();
		List<FreezeSalesOrderLine> resp = new Gson().fromJson(response, collectionType);
		
    	return resp;
	}
	
    public boolean ChangeMenuQuantity(int lineID, double newQuantity)
    {
    	// WEB SERVICE
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("lineid",String.valueOf(lineID));
		params.put("newquantity", String.valueOf(newQuantity));
	
  
		/*String response = */clientRest.webGet("DoChangeMenuQuantity/", params); 
			
		//GenericResult resp = new Gson().fromJson(response, GenericResult.class);
			
		return true;
    }
    
    public GenericResult UpdateMenuModifiers(int lineID, ArrayList<Integer> modifiers, String freeText)
    {
    	Log.i("getView()", "Service_Start");
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		String paramMod = "";
		for (int i=0; i< modifiers.size(); i++)
		{
			paramMod+= modifiers.get(i) + ",";
		}
		
		if (paramMod.length()>0)
			paramMod = paramMod.substring(0,paramMod.length()-1);
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("lineid", String.valueOf(lineID));
		params.put("modifiers", paramMod);
		params.put("freetext", freeText);
		
		Log.i("getView()", "Service_Parameters");
		
		String response = clientRest.webGet("UpdateMenuModifiers/", params); 
		GenericResult resp = new Gson().fromJson(response, GenericResult.class);

		return resp;
    }
    
    public GenericResult UpdateMenuOptionals(int lineID, ArrayList<FreezeSalesOrderLineOption> options)
    {
    
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("lineid", String.valueOf(lineID));
		
		String response = clientRest.webGet("UpdateMenuOptionals/", params); 
		GenericResult resp = new Gson().fromJson(response, GenericResult.class);

		return resp;
    }
    public void wcf_DoChangeCourse(int lineID, int newCourse)
    {
    	// WEB SERVICE
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("lineid",String.valueOf(lineID));
		params.put("newcourse", String.valueOf(newCourse));
		
		/*String response = */clientRest.webGet("DoChangeCourse/", params); 
			
		/*GenericResult resp = new Gson().fromJson(response, GenericResult.class);*/
    }
    
    public void wcf_DoChangeMenuCourse(int lineID, int newCourse)
    {
    	// WEB SERVICE
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("lineid",String.valueOf(lineID));
		params.put("newcourse", String.valueOf(newCourse));
		
		/*String response = */clientRest.webGet("DoChangeMenuCourse/", params); 
			
		/*GenericResult resp = new Gson().fromJson(response, GenericResult.class);*/
    }

	public List<PreOrderInfo> GetPreorderList() {
		
		 RestClient clientRest = new RestClient(Parameters.WcfUrl);
		 Map<String, String> params = new HashMap<String, String>();
			
		 params.put("deviceid", AndroidOperations.DeviceID);
		
		 
		 String response = clientRest.webGet("GetCurrentPreorders/", params); 

		 Type collectionType = new TypeToken<List<PreOrderInfo>>(){}.getType();
		 
		 List<PreOrderInfo> resp = new Gson().fromJson(response, collectionType);
		 
		 return resp;
	}
}
